Whamcloud - gitweb
44141c29cad23ddc7b5e9acb08ca1c2777c9021a
[fs/lustre-release.git] / lustre / tests / test-framework.sh
1 #!/bin/bash
2 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
3
4 trap 'print_summary && echo "test-framework exiting on error"' ERR
5 set -e
6 #set -x
7
8
9 export REFORMAT=${REFORMAT:-""}
10 export WRITECONF=${WRITECONF:-""}
11 export VERBOSE=false
12 export GMNALNID=${GMNALNID:-/usr/sbin/gmlndnid}
13 export CATASTROPHE=${CATASTROPHE:-/proc/sys/lnet/catastrophe}
14 export GSS=false
15 export GSS_KRB5=false
16 export GSS_PIPEFS=false
17 export IDENTITY_UPCALL=default
18
19 #export PDSH="pdsh -S -Rssh -w"
20
21 # function used by scripts run on remote nodes
22 LUSTRE=${LUSTRE:-$(cd $(dirname $0)/..; echo $PWD)}
23 . $LUSTRE/tests/functions.sh
24
25 assert_DIR () {
26     local failed=""
27     [[ $DIR/ = $MOUNT/* ]] || \
28         { failed=1 && echo "DIR=$DIR not in $MOUNT. Aborting."; }
29     [[ $DIR1/ = $MOUNT1/* ]] || \
30         { failed=1 && echo "DIR1=$DIR1 not in $MOUNT1. Aborting."; }
31     [[ $DIR2/ = $MOUNT2/* ]] || \
32         { failed=1 && echo "DIR2=$DIR2 not in $MOUNT2. Aborting"; }
33
34     [ -n "$failed" ] && exit 99 || true
35 }
36
37 usage() {
38     echo "usage: $0 [-r] [-f cfgfile]"
39     echo "       -r: reformat"
40
41     exit
42 }
43
44 print_summary () {
45     [ "$TESTSUITE" == "lfscktest" ] && return 0
46     [ -n "$ONLY" ] && echo "WARNING: ONLY is set to ${ONLY}."
47     local form="%-13s %-17s %s\n"
48     printf "$form" "status" "script" "skipped tests E(xcluded) S(low)"
49     echo "------------------------------------------------------------------------------------"
50     for O in $TESTSUITE_LIST; do
51         local skipped=""
52         local slow=""
53         local o=$(echo $O | tr "[:upper:]" "[:lower:]")
54         o=${o//_/-}
55         o=${o//tyn/tyN}
56         local log=${TMP}/${o}.log
57         [ -f $log ] && skipped=$(grep excluded $log | awk '{ printf " %s", $3 }' | sed 's/test_//g')
58         [ -f $log ] && slow=$(grep SLOW $log | awk '{ printf " %s", $3 }' | sed 's/test_//g')
59         [ "${!O}" = "done" ] && \
60             printf "$form" "Done" "$O" "E=$skipped" && \
61             [ -n "$slow" ] && printf "$form" "-" "-" "S=$slow"
62
63     done
64
65     for O in $TESTSUITE_LIST; do
66         [ "${!O}" = "no" ] && \
67             printf "$form" "Skipped" "$O" ""
68     done
69
70     for O in $TESTSUITE_LIST; do
71         [ "${!O}" = "done" -o "${!O}" = "no" ] || \
72             printf "$form" "UNFINISHED" "$O" ""
73     done
74 }
75
76 init_test_env() {
77     export LUSTRE=`absolute_path $LUSTRE`
78     export TESTSUITE=`basename $0 .sh`
79     export TEST_FAILED=false
80
81     export MKE2FS=${MKE2FS:-mke2fs}
82     export DEBUGFS=${DEBUGFS:-debugfs}
83     export TUNE2FS=${TUNE2FS:-tune2fs}
84     export E2LABEL=${E2LABEL:-e2label}
85     export DUMPE2FS=${DUMPE2FS:-dumpe2fs}
86     export E2FSCK=${E2FSCK:-e2fsck}
87
88     #[ -d /r ] && export ROOT=${ROOT:-/r}
89     export TMP=${TMP:-$ROOT/tmp}
90     export TESTSUITELOG=${TMP}/${TESTSUITE}.log
91     export HOSTNAME=${HOSTNAME:-`hostname`}
92     if ! echo $PATH | grep -q $LUSTRE/utils; then
93         export PATH=$PATH:$LUSTRE/utils
94     fi
95     if ! echo $PATH | grep -q $LUSTRE/utils/gss; then
96         export PATH=$PATH:$LUSTRE/utils/gss
97     fi
98     if ! echo $PATH | grep -q $LUSTRE/tests; then
99         export PATH=$PATH:$LUSTRE/tests
100     fi
101     export MDSRATE=${MDSRATE:-"$LUSTRE/tests/mpi/mdsrate"}
102     [ ! -f "$MDSRATE" ] && export MDSRATE=$(which mdsrate 2> /dev/null)
103     if ! echo $PATH | grep -q $LUSTRE/tests/racer; then
104         export PATH=$PATH:$LUSTRE/tests/racer
105     fi
106     if ! echo $PATH | grep -q $LUSTRE/tests/mpi; then
107         export PATH=$PATH:$LUSTRE/tests/mpi
108     fi
109     export LCTL=${LCTL:-"$LUSTRE/utils/lctl"}
110     [ ! -f "$LCTL" ] && export LCTL=$(which lctl)
111     export LFS=${LFS:-"$LUSTRE/utils/lfs"}
112     [ ! -f "$LFS" ] && export LFS=$(which lfs)
113     export L_GETIDENTITY=${L_GETIDENTITY:-"$LUSTRE/utils/l_getidentity"}
114     if [ ! -f "$L_GETIDENTITY" ]; then
115         if `which l_getidentity > /dev/null 2>&1`; then
116             export L_GETIDENTITY=$(which l_getidentity)
117         else
118             export L_GETIDENTITY=NONE
119         fi
120     fi
121     export MKFS=${MKFS:-"$LUSTRE/utils/mkfs.lustre"}
122     [ ! -f "$MKFS" ] && export MKFS=$(which mkfs.lustre)
123     export TUNEFS=${TUNEFS:-"$LUSTRE/utils/tunefs.lustre"}
124     [ ! -f "$TUNEFS" ] && export TUNEFS=$(which tunefs.lustre)
125     export CHECKSTAT="${CHECKSTAT:-"checkstat -v"} "
126     export FSTYPE=${FSTYPE:-"ldiskfs"}
127     export NAME=${NAME:-local}
128     export LGSSD=${LGSSD:-"$LUSTRE/utils/gss/lgssd"}
129     [ "$GSS_PIPEFS" = "true" ] && [ ! -f "$LGSSD" ] && \
130         export LGSSD=$(which lgssd)
131     export LSVCGSSD=${LSVCGSSD:-"$LUSTRE/utils/gss/lsvcgssd"}
132     [ ! -f "$LSVCGSSD" ] && export LSVCGSSD=$(which lsvcgssd 2> /dev/null)
133     export KRB5DIR=${KRB5DIR:-"/usr/kerberos"}
134     export DIR2
135     export SAVE_PWD=${SAVE_PWD:-$LUSTRE/tests}
136     export AT_MAX_PATH
137
138     if [ "$ACCEPTOR_PORT" ]; then
139         export PORT_OPT="--port $ACCEPTOR_PORT"
140     fi
141
142     case "x$SEC" in
143         xkrb5*)
144             echo "Using GSS/krb5 ptlrpc security flavor"
145             which lgss_keyring > /dev/null 2>&1 || \
146                 error "built with gss disabled! SEC=$SEC"
147             GSS=true
148             GSS_KRB5=true
149             ;;
150     esac
151
152     case "x$IDUP" in
153         xtrue)
154             IDENTITY_UPCALL=true
155             ;;
156         xfalse)
157             IDENTITY_UPCALL=false
158             ;;
159     esac
160
161     # Paths on remote nodes, if different
162     export RLUSTRE=${RLUSTRE:-$LUSTRE}
163     export RPWD=${RPWD:-$PWD}
164     export I_MOUNTED=${I_MOUNTED:-"no"}
165
166     # command line
167
168     while getopts "rvwf:" opt $*; do
169         case $opt in
170             f) CONFIG=$OPTARG;;
171             r) REFORMAT=--reformat;;
172             v) VERBOSE=true;;
173             w) WRITECONF=writeconf;;
174             \?) usage;;
175         esac
176     done
177
178     shift $((OPTIND - 1))
179     ONLY=${ONLY:-$*}
180
181     [ "$TESTSUITELOG" ] && rm -f $TESTSUITELOG || true
182     rm -f $TMP/*active
183
184 }
185
186 case `uname -r` in
187 2.4.*) EXT=".o"; USE_QUOTA=no; [ ! "$CLIENTONLY" ] && FSTYPE=ext3;;
188     *) EXT=".ko"; USE_QUOTA=yes;;
189 esac
190
191 load_module() {
192     EXT=".ko"
193     module=$1
194     shift
195     BASE=`basename $module $EXT`
196     lsmod | grep -q ${BASE} || \
197       if [ -f ${LUSTRE}/${module}${EXT} ]; then
198         insmod ${LUSTRE}/${module}${EXT} $@
199     else
200         # must be testing a "make install" or "rpm" installation
201         # note failed to load ptlrpc_gss is considered not fatal
202         if [ "$BASE" == "ptlrpc_gss" ]; then
203             modprobe $BASE $@ 2>/dev/null || echo "gss/krb5 is not supported"
204         else
205             modprobe $BASE $@
206         fi
207     fi
208 }
209
210 load_modules() {
211     if [ -n "$MODPROBE" ]; then
212         # use modprobe
213     return 0
214     fi
215     if [ "$HAVE_MODULES" = true ]; then
216     # we already loaded
217         return 0
218     fi
219     HAVE_MODULES=true
220
221     echo Loading modules from $LUSTRE
222     load_module ../libcfs/libcfs/libcfs
223     [ "$PTLDEBUG" ] && lctl set_param debug="$PTLDEBUG"
224     [ "$SUBSYSTEM" ] && lctl set_param subsystem_debug="${SUBSYSTEM# }"
225     local MODPROBECONF=
226     [ -f /etc/modprobe.conf ] && MODPROBECONF=/etc/modprobe.conf
227     [ ! "$MODPROBECONF" -a -d /etc/modprobe.d ] && MODPROBECONF=/etc/modprobe.d/Lustre
228     [ -z "$LNETOPTS" -a "$MODPROBECONF" ] && \
229         LNETOPTS=$(awk '/^options lnet/ { print $0}' $MODPROBECONF | sed 's/^options lnet //g')
230     echo $LNETOPTS | grep -q "accept=all"  || LNETOPTS="$LNETOPTS accept=all";
231     echo "lnet options: '$LNETOPTS'"
232     # note that insmod will ignore anything in modprobe.conf
233     load_module ../lnet/lnet/lnet $LNETOPTS
234     LNETLND=${LNETLND:-"socklnd/ksocklnd"}
235     load_module ../lnet/klnds/$LNETLND
236     load_module lvfs/lvfs
237     load_module obdclass/obdclass
238     load_module ptlrpc/ptlrpc
239     load_module ptlrpc/gss/ptlrpc_gss
240     [ "$USE_QUOTA" = "yes" -a "$LQUOTA" != "no" ] && load_module quota/lquota
241     load_module fld/fld
242     load_module fid/fid
243     load_module lmv/lmv
244     load_module mdc/mdc
245     load_module osc/osc
246     load_module lov/lov
247     load_module mgc/mgc
248     if [ -z "$CLIENTONLY" ] && [ -z "$CLIENTMODSONLY" ]; then
249         grep -q crc16 /proc/kallsyms || { modprobe crc16 2>/dev/null || true; }
250         grep -q jbd /proc/kallsyms || { modprobe jbd 2>/dev/null || true; }
251         [ "$FSTYPE" = "ldiskfs" ] && load_module ../ldiskfs/ldiskfs/ldiskfs
252         load_module mgs/mgs
253         load_module mds/mds
254         load_module mdd/mdd
255         load_module mdt/mdt
256         load_module lvfs/fsfilt_$FSTYPE
257         load_module cmm/cmm
258         load_module osd/osd
259         load_module ost/ost
260         load_module obdfilter/obdfilter
261     fi
262
263     load_module llite/lustre
264     load_module llite/llite_lloop
265     [ -d /r ] && OGDB=${OGDB:-"/r/tmp"}
266     OGDB=${OGDB:-$TMP}
267     rm -f $OGDB/ogdb-$HOSTNAME
268     $LCTL modules > $OGDB/ogdb-$HOSTNAME
269
270     # 'mount' doesn't look in $PATH, just sbin
271     [ -f $LUSTRE/utils/mount.lustre ] && cp $LUSTRE/utils/mount.lustre /sbin/. || true
272 }
273
274 RMMOD=rmmod
275 if [ `uname -r | cut -c 3` -eq 4 ]; then
276     RMMOD="modprobe -r"
277 fi
278
279 wait_for_lnet() {
280     local UNLOADED=0
281     local WAIT=0
282     local MAX=60
283     MODULES=$($LCTL modules | awk '{ print $2 }')
284     while [ -n "$MODULES" ]; do
285     sleep 5
286     $RMMOD $MODULES > /dev/null 2>&1 || true
287     MODULES=$($LCTL modules | awk '{ print $2 }')
288         if [ -z "$MODULES" ]; then
289         return 0
290         else
291             WAIT=$((WAIT + 5))
292             echo "waiting, $((MAX - WAIT)) secs left"
293         fi
294         if [ $WAIT -eq $MAX ]; then
295             echo "LNET modules $MODULES will not unload"
296         lsmod
297             return 3
298         fi
299     done
300 }
301
302 unload_dep_module() {
303     #lsmod output
304     #libcfs                107852  17 llite_lloop,lustre,obdfilter,ost,...
305     local MODULE=$1
306     local DEPS=$(lsmod | awk '($1 == "'$MODULE'") { print $4 }' | tr ',' ' ')
307     for SUBMOD in $DEPS; do
308         unload_dep_module $SUBMOD
309     done
310     [ "$MODULE" = "libcfs" ] && $LCTL dk $TMP/debug || true
311     $RMMOD $MODULE || true
312 }
313
314 check_mem_leak () {
315     LEAK_LUSTRE=$(dmesg | tail -n 30 | grep "obd_memory.*leaked" || true)
316     LEAK_PORTALS=$(dmesg | tail -n 20 | grep "Portals memory leaked" || true)
317     if [ "$LEAK_LUSTRE" -o "$LEAK_PORTALS" ]; then
318         echo "$LEAK_LUSTRE" 1>&2
319         echo "$LEAK_PORTALS" 1>&2
320         mv $TMP/debug $TMP/debug-leak.`date +%s` || true
321         echo "Memory leaks detected"
322         [ -n "$IGNORE_LEAK" ] && { echo "ignoring leaks" && return 0; } || true
323         return 1
324     fi
325 }
326
327 unload_modules() {
328     wait_exit_ST client # bug 12845
329
330     lsmod | grep libcfs > /dev/null && $LCTL dl
331     unload_dep_module $FSTYPE
332     unload_dep_module libcfs
333
334     local MODULES=$($LCTL modules | awk '{ print $2 }')
335     if [ -n "$MODULES" ]; then
336         echo "Modules still loaded: "
337         echo $MODULES
338         if [ "$(lctl dl)" ]; then
339             echo "Lustre still loaded"
340             lctl dl || true
341             lsmod
342             return 2
343         else
344             echo "Lustre stopped but LNET is still loaded, waiting..."
345             wait_for_lnet || return 3
346         fi
347
348     fi
349     HAVE_MODULES=false
350
351     check_mem_leak || return 254
352
353     echo "modules unloaded."
354     return 0
355 }
356
357 check_gss_daemon_facet() {
358     facet=$1
359     dname=$2
360
361     num=`do_facet $facet ps -o cmd -C $dname | grep $dname | wc -l`
362     if [ $num -ne 1 ]; then
363         echo "$num instance of $dname on $facet"
364         return 1
365     fi
366     return 0
367 }
368
369 send_sigint() {
370     local facet=$1
371     shift
372     do_facet $facet "killall -2 $@ 2>/dev/null || true"
373 }
374
375 start_gss_daemons() {
376     # starting on MDT
377     for num in `seq $MDSCOUNT`; do
378         do_facet mds$num "$LSVCGSSD -v"
379         if $GSS_PIPEFS; then
380             do_facet mds$num "$LGSSD -v"
381         fi
382     done
383     # starting on OSTs
384     for num in `seq $OSTCOUNT`; do
385         do_facet ost$num "$LSVCGSSD -v"
386     done
387     # starting on client
388     # FIXME: is "client" the right facet name?
389     if $GSS_PIPEFS; then
390         do_facet client "$LGSSD -v"
391     fi
392
393     # wait daemons entering "stable" status
394     sleep 5
395
396     #
397     # check daemons are running
398     #
399     for num in `seq $MDSCOUNT`; do
400         check_gss_daemon_facet mds$num lsvcgssd
401         if $GSS_PIPEFS; then
402             check_gss_daemon_facet mds$num lgssd
403         fi
404     done
405     for num in `seq $OSTCOUNT`; do
406         check_gss_daemon_facet ost$num lsvcgssd
407     done
408     if $GSS_PIPEFS; then
409         check_gss_daemon_facet client lgssd
410     fi
411 }
412
413 stop_gss_daemons() {
414     for num in `seq $MDSCOUNT`; do
415         send_sigint mds$num lsvcgssd lgssd
416     done
417     for num in `seq $OSTCOUNT`; do
418         send_sigint ost$num lsvcgssd
419     done
420     send_sigint client lgssd
421 }
422
423 init_gss() {
424     if $GSS; then
425         start_gss_daemons
426
427         if [ -n "$LGSS_KEYRING_DEBUG" ]; then
428             echo $LGSS_KEYRING_DEBUG > /proc/fs/lustre/sptlrpc/gss/lgss_keyring/debug_level
429         fi
430     fi
431 }
432
433 cleanup_gss() {
434     if $GSS; then
435         stop_gss_daemons
436         # maybe cleanup credential cache?
437     fi
438 }
439
440 mdsdevlabel() {
441     local num=$1
442     local device=`mdsdevname $num`
443     local label=`do_facet mds$num "e2label ${device}" | grep -v "CMD: "`
444     echo -n $label
445 }
446
447 ostdevlabel() {
448     local num=$1
449     local device=`ostdevname $num`
450     local label=`do_facet ost$num "e2label ${device}" | grep -v "CMD: "`
451     echo -n $label
452 }
453
454 # Facet functions
455 mount_facet() {
456     local facet=$1
457     shift
458     local dev=$(facet_active $facet)_dev
459     local opt=${facet}_opt
460     echo "Starting ${facet}: ${!opt} $@ ${!dev} ${MOUNT%/*}/${facet}"
461     do_facet ${facet} mount -t lustre ${!opt} $@ ${!dev} ${MOUNT%/*}/${facet}
462     RC=${PIPESTATUS[0]}
463     if [ $RC -ne 0 ]; then
464         echo "mount -t lustre $@ ${!dev} ${MOUNT%/*}/${facet}"
465         echo "Start of ${!dev} on ${facet} failed ${RC}"
466     else
467         do_facet ${facet} "lctl set_param debug=\\\"$PTLDEBUG\\\"; \
468             lctl set_param subsystem_debug=\\\"${SUBSYSTEM# }\\\"; \
469             lctl set_param debug_mb=${DEBUG_SIZE}; \
470             sync"
471
472         label=$(do_facet ${facet} "$E2LABEL ${!dev}")
473         [ -z "$label" ] && echo no label for ${!dev} && exit 1
474         eval export ${facet}_svc=${label}
475         echo Started ${label}
476     fi
477     return $RC
478 }
479
480 # start facet device options
481 start() {
482     local facet=$1
483     shift
484     local device=$1
485     shift
486     eval export ${facet}_dev=${device}
487     eval export ${facet}_opt=\"$@\"
488
489     local varname=${facet}failover_dev
490     if [ -n "${!varname}" ] ; then
491         eval export ${facet}failover_dev=${!varname}
492     else
493         eval export ${facet}failover_dev=$device
494     fi
495
496     do_facet ${facet} mkdir -p ${MOUNT%/*}/${facet}
497     mount_facet ${facet}
498     RC=$?
499     return $RC
500 }
501
502 stop() {
503     local running
504     local facet=$1
505     shift
506     HOST=`facet_active_host $facet`
507     [ -z $HOST ] && echo stop: no host for $facet && return 0
508
509     running=$(do_facet ${facet} "grep -c ${MOUNT%/*}/${facet}' ' /proc/mounts") || true
510     if [ ${running} -ne 0 ]; then
511         echo "Stopping ${MOUNT%/*}/${facet} (opts:$@)"
512         do_facet ${facet} umount -d $@ ${MOUNT%/*}/${facet}
513     fi
514
515     # umount should block, but we should wait for unrelated obd's
516     # like the MGS or MGC to also stop.
517     wait_exit_ST ${facet}
518 }
519
520 # save quota version (both administrative and operational quotas)
521 # add an additional parameter if mountpoint is ever different from $MOUNT
522 quota_save_version() {
523     local fsname=${2:-$FSNAME}
524     local spec=$1
525     local ver=$(tr -c -d "123" <<< $spec)
526     local type=$(tr -c -d "ug" <<< $spec)
527
528     [ -n "$ver" -a "$ver" != "3" ] && error "wrong quota version specifier"
529
530     $LFS quotaoff -ug $MOUNT # just in case
531     [ -n "$type" ] && { $LFS quotacheck -$type $MOUNT || error "quotacheck has failed"; }
532
533     do_facet mgs "lctl conf_param ${fsname}-MDT*.mdd.quota_type=$spec"
534     local varsvc
535     local osts=$(get_facets OST)
536     for ost in ${osts//,/ }; do
537         varsvc=${ost}_svc
538         do_facet mgs "lctl conf_param ${!varsvc}.ost.quota_type=$spec"
539     done
540 }
541
542 # client could mount several lustre 
543 quota_type () {
544     local fsname=${1:-$FSNAME}
545     local rc=0
546     do_facet mgs lctl get_param mdd.${fsname}-MDT*.quota_type || rc=$?
547     do_nodes $(comma_list $(osts_nodes)) \
548         lctl get_param obdfilter.${fsname}-OST*.quota_type || rc=$?
549     return $rc 
550 }
551
552 restore_quota_type () {
553    local mntpt=${1:-$MOUNT}
554    local quota_type=$(quota_type $FSNAME | grep MDT | cut -d "=" -f2)
555    if [ ! "$old_QUOTA_TYPE" ] || [ "$quota_type" = "$old_QUOTA_TYPE" ]; then
556         return
557    fi
558    quota_save_version $old_QUOTA_TYPE
559 }
560
561 setup_quota(){
562     local mntpt=$1
563
564     # We need:
565     # 1. run quotacheck only if quota is off
566     # 2. save the original quota_type params, restore them after testing
567
568     # Suppose that quota type the same on mds and ost
569     local quota_type=$(quota_type | grep MDT | cut -d "=" -f2)
570     [ ${PIPESTATUS[0]} -eq 0 ] || error "quota_type failed!"
571     echo "[HOST:$HOSTNAME] [old_quota_type:$quota_type] [new_quota_type:$QUOTA_TYPE]"
572     if [ "$quota_type" != "$QUOTA_TYPE" ]; then
573         export old_QUOTA_TYPE=$quota_type
574         quota_save_version $QUOTA_TYPE
575     fi
576
577     local quota_usrs=$QUOTA_USERS
578
579     # get_filesystem_size
580     local disksz=$(lfs df $mntpt | grep "filesystem summary:"  | awk '{print $3}')
581     local blk_soft=$((disksz + 1024))
582     local blk_hard=$((blk_soft + blk_soft / 20)) # Go 5% over
583
584     local Inodes=$(lfs df -i $mntpt | grep "filesystem summary:"  | awk '{print $3}')
585     local i_soft=$Inodes
586     local i_hard=$((i_soft + i_soft / 20))
587
588     echo "Total disk size: $disksz  block-softlimit: $blk_soft block-hardlimit:
589         $blk_hard inode-softlimit: $i_soft inode-hardlimit: $i_hard"
590
591     local cmd
592     for usr in $quota_usrs; do
593         echo "Setting up quota on $HOSTNAME:$mntpt for $usr..."
594         for type in u g; do
595             cmd="$LFS setquota -$type $usr -b $blk_soft -B $blk_hard -i $i_soft -I $i_hard $mntpt"
596             echo "+ $cmd"
597             eval $cmd || error "$cmd FAILED!"
598         done
599         # display the quota status
600         echo "Quota settings for $usr : "
601         $LFS quota -v -u $usr $mntpt || true
602     done
603 }
604
605 zconf_mount() {
606     local OPTIONS
607     local client=$1
608     local mnt=$2
609     # Only supply -o to mount if we have options
610     if [ -n "$MOUNTOPT" ]; then
611         OPTIONS="-o $MOUNTOPT"
612     fi
613     local device=$MGSNID:/$FSNAME
614     if [ -z "$mnt" -o -z "$FSNAME" ]; then
615         echo Bad zconf mount command: opt=$OPTIONS dev=$device mnt=$mnt
616         exit 1
617     fi
618
619     echo "Starting client: $client: $OPTIONS $device $mnt"
620     do_node $client mkdir -p $mnt
621     do_node $client mount -t lustre $OPTIONS $device $mnt || return 1
622
623     do_node $client "lctl set_param debug=\\\"$PTLDEBUG\\\";
624         lctl set_param subsystem_debug=\\\"${SUBSYSTEM# }\\\";
625         lctl set_param debug_mb=${DEBUG_SIZE}"
626
627     return 0
628 }
629
630 zconf_umount() {
631     local client=$1
632     local mnt=$2
633     local force
634     local busy 
635     local need_kill
636
637     [ "$3" ] && force=-f
638     local running=$(do_node $client "grep -c $mnt' ' /proc/mounts") || true
639     if [ $running -ne 0 ]; then
640         echo "Stopping client $client $mnt (opts:$force)"
641         do_node $client lsof -t $mnt || need_kill=no
642         if [ "x$force" != "x" -a "x$need_kill" != "xno" ]; then
643             pids=$(do_node $client lsof -t $mnt | sort -u);
644             if [ -n $pids ]; then
645                 do_node $client kill -9 $pids || true
646             fi
647         fi
648
649         busy=$(do_node $client "umount $force $mnt 2>&1" | grep -c "busy") || true
650         if [ $busy -ne 0 ] ; then
651             echo "$mnt is still busy, wait one second" && sleep 1
652             do_node $client umount $force $mnt
653         fi
654     fi
655 }
656
657 # nodes is comma list
658 sanity_mount_check_nodes () {
659     local nodes=$1
660     shift
661     local mnts="$@"
662     local mnt
663
664     # FIXME: assume that all cluster nodes run the same os
665     [ "$(uname)" = Linux ] || return 0
666
667     local rc=0
668     for mnt in $mnts ; do
669         do_nodes $nodes "running=\\\$(grep -c $mnt' ' /proc/mounts);
670 mpts=\\\$(mount | grep -w -c $mnt);
671 if [ \\\$running -ne \\\$mpts ]; then
672     echo \\\$(hostname) env are INSANE!;
673     exit 1;
674 fi"
675     [ $? -eq 0 ] || rc=1 
676     done
677     return $rc
678 }
679
680 sanity_mount_check_servers () {
681     [ "$CLIENTONLY" ] && 
682         { echo "CLIENTONLY mode, skip mount_check_servers"; return 0; } || true
683     echo Checking servers environments
684
685     # FIXME: modify get_facets to display all facets wo params
686     local facets="$(get_facets OST),$(get_facets MDS)"
687     local node
688     local mnt
689     local facet
690     for facet in ${facets//,/ }; do
691         node=$(facet_host ${facet})
692         mnt=${MOUNT%/*}/${facet}
693         sanity_mount_check_nodes $node $mnt ||
694             { error "server $node environments are insane!"; return 1; }
695     done
696 }
697
698 sanity_mount_check_clients () {
699     local clients=${1:-$CLIENTS}
700     local mntpt=${2:-$MOUNT}
701     local mntpt2=${3:-$MOUNT2}
702
703     [ -z $clients ] && clients=$(hostname)
704     echo Checking clients $clients environments
705
706     sanity_mount_check_nodes $clients $mntpt $mntpt2 ||
707        error "clients environments are insane!"
708 }
709
710 sanity_mount_check () {
711     sanity_mount_check_servers || return 1
712     sanity_mount_check_clients || return 2
713 }
714
715 # mount clients if not mouted
716 zconf_mount_clients() {
717     local OPTIONS
718     local clients=$1
719     local mnt=$2
720
721
722     # Only supply -o to mount if we have options
723     if [ -n "$MOUNTOPT" ]; then
724         OPTIONS="-o $MOUNTOPT"
725     fi
726     local device=$MGSNID:/$FSNAME
727     if [ -z "$mnt" -o -z "$FSNAME" ]; then
728         echo Bad zconf mount command: opt=$OPTIONS dev=$device mnt=$mnt
729         exit 1
730     fi
731
732     echo "Starting client $clients: $OPTIONS $device $mnt"
733
734     do_nodes $clients "
735 running=\\\$(mount | grep -c $mnt' ');
736 rc=0;
737 if [ \\\$running -eq 0 ] ; then
738     mkdir -p $mnt;
739     mount -t lustre $OPTIONS $device $mnt;
740     rc=$?;
741 fi;
742 exit $rc"
743
744     echo "Started clients $clients: "
745     do_nodes $clients "mount | grep -w $mnt"
746
747     do_nodes $clients "lctl set_param debug=\\\"$PTLDEBUG\\\";
748         lctl set_param subsystem_debug=\\\"${SUBSYSTEM# }\\\";
749         lctl set_param debug_mb=${DEBUG_SIZE};"
750
751     return 0
752 }
753
754 zconf_umount_clients() {
755     local clients=$1
756     local mnt=$2
757     local force
758
759     [ "$3" ] && force=-f
760
761     echo "Stopping clients: $clients $mnt (opts:$force)"
762     do_nodes $clients "running=\\\$(grep -c $mnt' ' /proc/mounts);
763 if [ \\\$running -ne 0 ] ; then
764 echo Stopping client \\\$(hostname) client $mnt opts:$force;
765 lsof -t $mnt || need_kill=no;
766 if [ "x$force" != "x" -a "x\\\$need_kill" != "xno" ]; then
767     pids=\\\$(lsof -t $mnt | sort -u);
768     if [ -n \\\"\\\$pids\\\" ]; then
769              kill -9 \\\$pids;
770     fi
771 fi;
772 busy=\\\$(umount $force $mnt 2>&1 | grep -c "busy");
773 if [ \\\$busy -ne 0 ] ; then
774     echo "$mnt is still busy, wait one second" && sleep 1;
775     umount $force $mnt;
776 fi
777 fi"
778 }
779
780 shudown_node_hard () {
781     local host=$1
782     local attempts=3
783
784     for i in $(seq $attempts) ; do
785         $POWER_DOWN $host
786         sleep 1
787         ping -w 3 -c 1 $host > /dev/null 2>&1 || return 0
788         echo "waiting for $host to fail attempts=$attempts"
789         [ $i -lt $attempts ] || \
790             { echo "$host still pingable after power down! attempts=$attempts" && return 1; } 
791     done
792 }
793
794 shutdown_client() {
795     local client=$1
796     local mnt=${2:-$MOUNT}
797     local attempts=3
798
799     if [ "$FAILURE_MODE" = HARD ]; then
800         shudown_node_hard $client 
801     else
802        zconf_umount_clients $client $mnt -f
803     fi
804 }
805
806 shutdown_facet() {
807     local facet=$1
808     if [ "$FAILURE_MODE" = HARD ]; then
809         shudown_node_hard $(facet_active_host $facet)
810     elif [ "$FAILURE_MODE" = SOFT ]; then
811         stop $facet
812     fi
813 }
814
815 reboot_facet() {
816     facet=$1
817     if [ "$FAILURE_MODE" = HARD ]; then
818         $POWER_UP `facet_active_host $facet`
819     else
820         sleep 10
821     fi
822 }
823
824 boot_node() {
825     local node=$1
826     if [ "$FAILURE_MODE" = HARD ]; then
827        $POWER_UP $node
828     fi
829 }
830
831 # recovery-scale functions
832 check_progs_installed () {
833     local clients=$1
834     shift
835     local progs=$@
836
837     do_nodes $clients "PATH=:$PATH; status=true;
838 for prog in $progs; do
839     if ! [ \\\"\\\$(which \\\$prog)\\\"  -o  \\\"\\\${!prog}\\\" ]; then
840        echo \\\$prog missing on \\\$(hostname);
841        status=false;
842     fi
843 done;
844 eval \\\$status"
845 }
846
847 client_var_name() {
848     echo __$(echo $1 | tr '-' 'X')
849 }
850
851 start_client_load() {
852     local client=$1
853     local load=$2
854     local var=$(client_var_name $client)_load
855     eval export ${var}=$load
856
857     do_node $client "PATH=$PATH MOUNT=$MOUNT ERRORS_OK=$ERRORS_OK \
858                               BREAK_ON_ERROR=$BREAK_ON_ERROR \
859                               END_RUN_FILE=$END_RUN_FILE \
860                               LOAD_PID_FILE=$LOAD_PID_FILE \
861                               TESTSUITELOG=$TESTSUITELOG \
862                               run_${load}.sh" &
863     CLIENT_LOAD_PIDS="$CLIENT_LOAD_PIDS $!"
864     log "Started client load: ${load} on $client"
865
866     return 0
867 }
868
869 start_client_loads () {
870     local -a clients=(${1//,/ })
871     local numloads=${#CLIENT_LOADS[@]}
872     local testnum
873
874     for ((nodenum=0; nodenum < ${#clients[@]}; nodenum++ )); do
875         testnum=$((nodenum % numloads))
876         start_client_load ${clients[nodenum]} ${CLIENT_LOADS[testnum]}
877     done
878 }
879
880 # only for remote client 
881 check_client_load () {
882     local client=$1
883     local var=$(client_var_name $client)_load
884     local TESTLOAD=run_${!var}.sh
885
886     ps auxww | grep -v grep | grep $client | grep -q "$TESTLOAD" || return 1
887     
888     # bug 18914: try to connect several times not only when
889     # check ps, but  while check_catastrophe also
890     local tries=3
891     local RC=254
892     while [ $RC = 254 -a $tries -gt 0 ]; do
893         let tries=$tries-1
894         # assume success
895         RC=0
896         if ! check_catastrophe $client; then
897             RC=${PIPESTATUS[0]}
898             if [ $RC -eq 254 ]; then
899                 # FIXME: not sure how long we shuold sleep here
900                 sleep 10
901                 continue
902             fi
903             echo "check catastrophe failed: RC=$RC "
904             return $RC
905         fi
906     done
907     # We can continue try to connect if RC=254
908     # Just print the warning about this
909     if [ $RC = 254 ]; then
910         echo "got a return status of $RC from do_node while checking catastrophe on $client"
911     fi
912
913     # see if the load is still on the client
914     tries=3
915     RC=254
916     while [ $RC = 254 -a $tries -gt 0 ]; do
917         let tries=$tries-1
918         # assume success
919         RC=0
920         if ! do_node $client "ps auxwww | grep -v grep | grep -q $TESTLOAD"; then
921             RC=${PIPESTATUS[0]}
922             sleep 30
923         fi
924     done
925     if [ $RC = 254 ]; then
926         echo "got a return status of $RC from do_node while checking (catastrophe and 'ps') the client load on $client"
927         # see if we can diagnose a bit why this is
928     fi
929
930     return $RC
931 }
932 check_client_loads () {
933    local clients=${1//,/ }
934    local client=
935    local rc=0
936
937    for client in $clients; do
938       check_client_load $client
939       rc=${PIPESTATUS[0]}
940       if [ "$rc" != 0 ]; then
941         log "Client load failed on node $client, rc=$rc"
942         return $rc
943       fi
944    done
945 }
946
947 restart_client_loads () {
948     local clients=${1//,/ }
949     local expectedfail=${2:-""}
950     local client=
951     local rc=0
952
953     for client in $clients; do
954         check_client_load $client
955         rc=${PIPESTATUS[0]}
956         if [ "$rc" != 0 -a "$expectedfail" ]; then
957             start_client_load $client
958             echo "Restarted client load: on $client. Checking ..."
959             check_client_load $client 
960             rc=${PIPESTATUS[0]}
961             if [ "$rc" != 0 ]; then
962                 log "Client load failed to restart on node $client, rc=$rc"
963                 # failure one client load means test fail
964                 # we do not need to check other 
965                 return $rc
966             fi
967         else
968             return $rc
969         fi
970     done
971 }
972 # End recovery-scale functions
973
974 # verify that lustre actually cleaned up properly
975 cleanup_check() {
976     [ -f $CATASTROPHE ] && [ `cat $CATASTROPHE` -ne 0 ] && \
977         error "LBUG/LASSERT detected"
978     BUSY=`dmesg | grep -i destruct || true`
979     if [ "$BUSY" ]; then
980         echo "$BUSY" 1>&2
981         [ -e $TMP/debug ] && mv $TMP/debug $TMP/debug-busy.`date +%s`
982         exit 205
983     fi
984
985     check_mem_leak || exit 204
986
987     [ "`lctl dl 2> /dev/null | wc -l`" -gt 0 ] && lctl dl && \
988         echo "$0: lustre didn't clean up..." 1>&2 && return 202 || true
989
990     if [ "`/sbin/lsmod 2>&1 | egrep 'lnet|libcfs'`" ]; then
991         echo "$0: modules still loaded..." 1>&2
992         /sbin/lsmod 1>&2
993         return 203
994     fi
995     return 0
996 }
997
998 wait_update () {
999     local node=$1
1000     local TEST=$2
1001     local FINAL=$3
1002     local MAX=${4:-90}
1003
1004         local RESULT
1005         local WAIT=0
1006         local sleep=5
1007         while [ true ]; do
1008             RESULT=$(do_node $node "$TEST")
1009             if [ "$RESULT" == "$FINAL" ]; then
1010                 echo "Updated after $WAIT sec: wanted '$FINAL' got '$RESULT'"
1011                 return 0
1012             fi
1013             [ $WAIT -ge $MAX ] && break
1014             echo "Waiting $((MAX - WAIT)) secs for update"
1015             WAIT=$((WAIT + sleep))
1016             sleep $sleep
1017         done
1018         echo "Update not seen after $MAX sec: wanted '$FINAL' got '$RESULT'"
1019         return 3
1020 }
1021
1022 wait_update_facet () {
1023     local facet=$1
1024     wait_update  $(facet_active_host $facet) "$@"
1025 }
1026
1027 wait_delete_completed () {
1028     local TOTALPREV=`lctl get_param -n osc.*.kbytesavail | \
1029                      awk 'BEGIN{total=0}; {total+=$1}; END{print total}'`
1030
1031     local WAIT=0
1032     local MAX_WAIT=20
1033     while [ "$WAIT" -ne "$MAX_WAIT" ]; do
1034         sleep 1
1035         TOTAL=`lctl get_param -n osc.*.kbytesavail | \
1036                awk 'BEGIN{total=0}; {total+=$1}; END{print total}'`
1037         [ "$TOTAL" -eq "$TOTALPREV" ] && break
1038         echo "Waiting delete completed ... prev: $TOTALPREV current: $TOTAL "
1039         TOTALPREV=$TOTAL
1040         WAIT=$(( WAIT + 1))
1041     done
1042     echo "Delete completed."
1043 }
1044
1045 wait_for_host() {
1046     local host=$1
1047     check_network "$host" 900
1048     while ! do_node $host "ls -d $LUSTRE " > /dev/null; do sleep 5; done
1049 }
1050
1051 wait_for() {
1052     local facet=$1
1053     local host=`facet_active_host $facet`
1054     wait_for_host $host
1055 }
1056
1057 wait_recovery_complete () {
1058     local facet=$1
1059
1060     # Use default policy if $2 is not passed by caller. 
1061     #define OBD_RECOVERY_TIMEOUT (obd_timeout * 5 / 2)
1062     # as we are in process of changing obd_timeout in different ways
1063     # let's set MAX longer than that
1064     local MAX=${2:-$(( TIMEOUT * 4 ))}
1065  
1066     local var_svc=${facet}_svc
1067     local procfile="*.${!var_svc}.recovery_status"
1068     local WAIT=0
1069     local STATUS=
1070
1071     while [ $WAIT -lt $MAX ]; do
1072         STATUS=$(do_facet $facet lctl get_param -n $procfile | grep status)
1073         [[ $STATUS = "status: COMPLETE" ]] && return 0
1074         sleep 5
1075         WAIT=$((WAIT + 5))
1076         echo "Waiting $((MAX - WAIT)) secs for $facet recovery done. $STATUS"
1077     done
1078     echo "$facet recovery not done in $MAX sec. $STATUS"
1079     return 1
1080 }
1081
1082 wait_exit_ST () {
1083     local facet=$1
1084
1085     local WAIT=0
1086     local INTERVAL=1
1087     local running
1088     # conf-sanity 31 takes a long time cleanup
1089     while [ $WAIT -lt 300 ]; do
1090         running=$(do_facet ${facet} "lsmod | grep lnet > /dev/null && lctl dl | grep ' ST '") || true
1091         [ -z "${running}" ] && return 0
1092         echo "waited $WAIT for${running}"
1093         [ $INTERVAL -lt 64 ] && INTERVAL=$((INTERVAL + INTERVAL))
1094         sleep $INTERVAL
1095         WAIT=$((WAIT + INTERVAL))
1096     done
1097     echo "service didn't stop after $WAIT seconds.  Still running:"
1098     echo ${running}
1099     return 1
1100 }
1101
1102 wait_remote_prog () {
1103    local prog=$1
1104    local WAIT=0
1105    local INTERVAL=5
1106    local rc=0
1107
1108    [ "$PDSH" = "no_dsh" ] && return 0
1109
1110    while [ $WAIT -lt $2 ]; do
1111         running=$(ps uax | grep "$PDSH.*$prog.*$MOUNT" | grep -v grep) || true
1112         [ -z "${running}" ] && return 0 || true
1113         echo "waited $WAIT for: "
1114         echo "$running"
1115         [ $INTERVAL -lt 60 ] && INTERVAL=$((INTERVAL + INTERVAL))
1116         sleep $INTERVAL
1117         WAIT=$((WAIT + INTERVAL))
1118     done
1119     local pids=$(ps  uax | grep "$PDSH.*$prog.*$MOUNT" | grep -v grep | awk '{print $2}')
1120     [ -z "$pids" ] && return 0
1121     echo "$PDSH processes still exists after $WAIT seconds.  Still running: $pids"
1122     # FIXME: not portable
1123     for pid in $pids; do
1124         cat /proc/${pid}/status || true
1125         cat /proc/${pid}/wchan || true
1126         echo "Killing $pid"
1127         kill -9 $pid || true
1128         sleep 1
1129         ps -P $pid && rc=1
1130     done
1131
1132     return $rc
1133 }
1134
1135 client_df() {
1136     # not every config has many clients
1137     if [ ! -z "$CLIENTS" ]; then
1138         $PDSH $CLIENTS "df $MOUNT" > /dev/null
1139     else
1140         df $MOUNT > /dev/null
1141     fi
1142 }
1143
1144 client_reconnect() {
1145     uname -n >> $MOUNT/recon
1146     if [ -z "$CLIENTS" ]; then
1147         df $MOUNT; uname -n >> $MOUNT/recon
1148     else
1149         do_nodes $CLIENTS "df $MOUNT; uname -n >> $MOUNT/recon" > /dev/null
1150     fi
1151     echo Connected clients:
1152     cat $MOUNT/recon
1153     ls -l $MOUNT/recon > /dev/null
1154     rm $MOUNT/recon
1155 }
1156
1157 facet_failover() {
1158     local facet=$1
1159     local sleep_time=$2
1160     echo "Failing $facet on node `facet_active_host $facet`"
1161     shutdown_facet $facet
1162     [ -n "$sleep_time" ] && sleep $sleep_time
1163     reboot_facet $facet
1164     change_active $facet
1165     local TO=`facet_active_host $facet`
1166     echo "Failover $facet to $TO"
1167     wait_for $facet
1168     mount_facet $facet || error "Restart of $facet failed"
1169 }
1170
1171 obd_name() {
1172     local facet=$1
1173 }
1174
1175 replay_barrier() {
1176     local facet=$1
1177     do_facet $facet sync
1178     df $MOUNT
1179     local svc=${facet}_svc
1180     do_facet $facet $LCTL --device %${!svc} notransno
1181     do_facet $facet $LCTL --device %${!svc} readonly
1182     do_facet $facet $LCTL mark "$facet REPLAY BARRIER on ${!svc}"
1183     $LCTL mark "local REPLAY BARRIER on ${!svc}"
1184 }
1185
1186 replay_barrier_nodf() {
1187     local facet=$1    echo running=${running}
1188     do_facet $facet sync
1189     local svc=${facet}_svc
1190     echo Replay barrier on ${!svc}
1191     do_facet $facet $LCTL --device %${!svc} notransno
1192     do_facet $facet $LCTL --device %${!svc} readonly
1193     do_facet $facet $LCTL mark "$facet REPLAY BARRIER on ${!svc}"
1194     $LCTL mark "local REPLAY BARRIER on ${!svc}"
1195 }
1196
1197 replay_barrier_nosync() {
1198     local facet=$1    echo running=${running}
1199     local svc=${facet}_svc
1200     echo Replay barrier on ${!svc}
1201     do_facet $facet $LCTL --device %${!svc} notransno
1202     do_facet $facet $LCTL --device %${!svc} readonly
1203     do_facet $facet $LCTL mark "$facet REPLAY BARRIER on ${!svc}"
1204     $LCTL mark "local REPLAY BARRIER on ${!svc}"
1205 }
1206
1207 mds_evict_client() {
1208     UUID=`lctl get_param -n mdc.${mds1_svc}-mdc-*.uuid`
1209     do_facet mds1 "lctl set_param -n mdt.${mds1_svc}.evict_client $UUID"
1210 }
1211
1212 ost_evict_client() {
1213     UUID=`lctl get_param -n devices| grep ${ost1_svc}-osc- | egrep -v 'MDT' | awk '{print $5}'`
1214     do_facet ost1 "lctl set_param -n obdfilter.${ost1_svc}.evict_client $UUID"
1215 }
1216
1217 fail() {
1218     facet_failover $* || error "failover: $?"
1219     client_df || error "post-failover df: $?"
1220 }
1221
1222 fail_nodf() {
1223         local facet=$1
1224         facet_failover $facet
1225 }
1226
1227 fail_abort() {
1228     local facet=$1
1229     stop $facet
1230     change_active $facet
1231     mount_facet $facet -o abort_recovery
1232     client_df || echo "first df failed: $?"
1233     sleep 1
1234     client_df || error "post-failover df: $?"
1235 }
1236
1237 do_lmc() {
1238     echo There is no lmc.  This is mountconf, baby.
1239     exit 1
1240 }
1241
1242 h2gm () {
1243     if [ "$1" = "client" -o "$1" = "'*'" ]; then echo \'*\'; else
1244         ID=`$PDSH $1 $GMNALNID -l | cut -d\  -f2`
1245         echo $ID"@gm"
1246     fi
1247 }
1248
1249 h2name_or_ip() {
1250     if [ "$1" = "client" -o "$1" = "'*'" ]; then echo \'*\'; else
1251         echo $1"@$2"
1252     fi
1253 }
1254
1255 h2ptl() {
1256    if [ "$1" = "client" -o "$1" = "'*'" ]; then echo \'*\'; else
1257        ID=`xtprocadmin -n $1 2>/dev/null | egrep -v 'NID' | awk '{print $1}'`
1258        if [ -z "$ID" ]; then
1259            echo "Could not get a ptl id for $1..."
1260            exit 1
1261        fi
1262        echo $ID"@ptl"
1263    fi
1264 }
1265 declare -fx h2ptl
1266
1267 h2tcp() {
1268     h2name_or_ip "$1" "tcp"
1269 }
1270 declare -fx h2tcp
1271
1272 h2elan() {
1273     if [ "$1" = "client" -o "$1" = "'*'" ]; then echo \'*\'; else
1274         if type __h2elan >/dev/null 2>&1; then
1275             ID=$(__h2elan $1)
1276         else
1277             ID=`echo $1 | sed 's/[^0-9]*//g'`
1278         fi
1279         echo $ID"@elan"
1280     fi
1281 }
1282 declare -fx h2elan
1283
1284 h2openib() {
1285     h2name_or_ip "$1" "openib"
1286 }
1287 declare -fx h2openib
1288
1289 h2o2ib() {
1290     h2name_or_ip "$1" "o2ib"
1291 }
1292 declare -fx h2o2ib
1293
1294 facet_host() {
1295     local facet=$1
1296
1297     [ "$facet" == client ] && echo -n $HOSTNAME && return
1298     varname=${facet}_HOST
1299     if [ -z "${!varname}" ]; then
1300         if [ "${facet:0:3}" == "ost" ]; then
1301             eval ${facet}_HOST=${ost_HOST}
1302         fi
1303     fi
1304     echo -n ${!varname}
1305 }
1306
1307 facet_active() {
1308     local facet=$1
1309     local activevar=${facet}active
1310
1311     if [ -f $TMP/${facet}active ] ; then
1312         source $TMP/${facet}active
1313     fi
1314
1315     active=${!activevar}
1316     if [ -z "$active" ] ; then
1317         echo -n ${facet}
1318     else
1319         echo -n ${active}
1320     fi
1321 }
1322
1323 facet_active_host() {
1324     local facet=$1
1325     local active=`facet_active $facet`
1326     if [ "$facet" == client ]; then
1327         echo $HOSTNAME
1328     else
1329         echo `facet_host $active`
1330     fi
1331 }
1332
1333 change_active() {
1334     local facet=$1
1335     local failover=${facet}failover
1336     host=`facet_host $failover`
1337     [ -z "$host" ] && return
1338     local curactive=`facet_active $facet`
1339     if [ -z "${curactive}" -o "$curactive" == "$failover" ] ; then
1340         eval export ${facet}active=$facet
1341     else
1342         eval export ${facet}active=$failover
1343     fi
1344     # save the active host for this facet
1345     local activevar=${facet}active
1346     echo "$activevar=${!activevar}" > $TMP/$activevar
1347 }
1348
1349 do_node() {
1350     local verbose=false
1351     # do not stripe off hostname if verbose, bug 19215
1352     if [ x$1 = x--verbose ]; then
1353         shift
1354         verbose=true
1355     fi
1356
1357     local HOST=$1
1358     shift
1359     local myPDSH=$PDSH
1360     if [ "$HOST" = "$HOSTNAME" ]; then
1361         myPDSH="no_dsh"
1362     elif [ -z "$myPDSH" -o "$myPDSH" = "no_dsh" ]; then
1363         echo "cannot run remote command on $HOST with $myPDSH"
1364         return 128
1365     fi
1366     if $VERBOSE; then
1367         echo "CMD: $HOST $@" >&2
1368         $myPDSH $HOST $LCTL mark "$@" > /dev/null 2>&1 || :
1369     fi
1370
1371     if [ "$myPDSH" = "rsh" ]; then
1372 # we need this because rsh does not return exit code of an executed command
1373         local command_status="$TMP/cs"
1374         rsh $HOST ":> $command_status"
1375         rsh $HOST "(PATH=\$PATH:$RLUSTRE/utils:$RLUSTRE/tests:/sbin:/usr/sbin;
1376                     cd $RPWD; sh -c \"$@\") ||
1377                     echo command failed >$command_status"
1378         [ -n "$($myPDSH $HOST cat $command_status)" ] && return 1 || true
1379         return 0
1380     fi
1381
1382     if $verbose ; then
1383         # print HOSTNAME for myPDSH="no_dsh"
1384         if [[ $myPDSH = no_dsh ]]; then
1385             $myPDSH $HOST "(PATH=\$PATH:$RLUSTRE/utils:$RLUSTRE/tests:/sbin:/usr/sbin; cd $RPWD; sh -c \"$@\")" | sed -e "s/^/${HOSTNAME}: /"
1386         else
1387             $myPDSH $HOST "(PATH=\$PATH:$RLUSTRE/utils:$RLUSTRE/tests:/sbin:/usr/sbin; cd $RPWD; sh -c \"$@\")"
1388         fi
1389     else
1390         $myPDSH $HOST "(PATH=\$PATH:$RLUSTRE/utils:$RLUSTRE/tests:/sbin:/usr/sbin; cd $RPWD; sh -c \"$@\")" | sed "s/^${HOST}: //"
1391     fi
1392     return ${PIPESTATUS[0]}
1393 }
1394
1395 single_local_node () {
1396    [ "$1" = "$HOSTNAME" ]
1397 }
1398
1399 do_nodes() {
1400     local verbose=false
1401     # do not stripe off hostname if verbose, bug 19215
1402     if [ x$1 = x--verbose ]; then
1403         shift
1404         verbose=true
1405     fi
1406
1407     local rnodes=$1
1408     shift
1409
1410     if $(single_local_node $rnodes); then
1411         do_node --verbose $rnodes $@
1412         return $?
1413     fi
1414
1415     # This is part from do_node
1416     local myPDSH=$PDSH
1417
1418     [ -z "$myPDSH" -o "$myPDSH" = "no_dsh" -o "$myPDSH" = "rsh" ] && \
1419         echo "cannot run remote command on $rnodes with $myPDSH" && return 128
1420
1421     if $VERBOSE; then
1422         echo "CMD: $rnodes $@" >&2
1423         $myPDSH $rnodes $LCTL mark "$@" > /dev/null 2>&1 || :
1424     fi
1425
1426     if $verbose ; then
1427         $myPDSH $rnodes "(PATH=\$PATH:$RLUSTRE/utils:$RLUSTRE/tests:/sbin:/usr/sbin; cd $RPWD; sh -c \"$@\")"
1428     else
1429         $myPDSH $rnodes "(PATH=\$PATH:$RLUSTRE/utils:$RLUSTRE/tests:/sbin:/usr/sbin; cd $RPWD; sh -c \"$@\")" | sed -re "s/\w+:\s//g"
1430     fi
1431     return ${PIPESTATUS[0]}
1432 }
1433
1434 do_facet() {
1435     local facet=$1
1436     shift
1437     local HOST=`facet_active_host $facet`
1438     [ -z $HOST ] && echo No host defined for facet ${facet} && exit 1
1439     do_node $HOST "$@"
1440 }
1441
1442 add() {
1443     local facet=$1
1444     shift
1445     # make sure its not already running
1446     stop ${facet} -f
1447     rm -f $TMP/${facet}active
1448     do_facet ${facet} $MKFS $*
1449 }
1450
1451 ostdevname() {
1452     num=$1
1453     DEVNAME=OSTDEV$num
1454     #if $OSTDEVn isn't defined, default is $OSTDEVBASE + num
1455     eval DEVPTR=${!DEVNAME:=${OSTDEVBASE}${num}}
1456     echo -n $DEVPTR
1457 }
1458
1459 mdsdevname() {
1460     num=$1
1461     DEVNAME=MDSDEV$num
1462     #if $MDSDEVn isn't defined, default is $MDSDEVBASE + num
1463     eval DEVPTR=${!DEVNAME:=${MDSDEVBASE}${num}}
1464     echo -n $DEVPTR
1465 }
1466
1467 ########
1468 ## MountConf setup
1469
1470 stopall() {
1471     # make sure we are using the primary server, so test-framework will
1472     # be able to clean up properly.
1473     activemds=`facet_active mds1`
1474     if [ $activemds != "mds1" ]; then
1475         fail mds1
1476     fi
1477
1478     local clients=$CLIENTS
1479     [ -z $clients ] && clients=$(hostname)
1480
1481     zconf_umount_clients $clients $MOUNT "$*" || true
1482     [ -n "$MOUNT2" ] && zconf_umount_clients $clients $MOUNT2 "$*" || true
1483
1484     [ "$CLIENTONLY" ] && return
1485     # The add fn does rm ${facet}active file, this would be enough
1486     # if we use do_facet <facet> only after the facet added, but
1487     # currently we use do_facet mds in local.sh
1488     for num in `seq $MDSCOUNT`; do
1489         stop mds$num -f
1490         rm -f ${TMP}/mds${num}active
1491     done
1492
1493     for num in `seq $OSTCOUNT`; do
1494         stop ost$num -f
1495         rm -f $TMP/ost${num}active
1496     done
1497
1498     return 0
1499 }
1500
1501 cleanupall() {
1502     nfs_client_mode && return
1503
1504     stopall $*
1505     unload_modules
1506     cleanup_gss
1507 }
1508
1509 mdsmkfsopts()
1510 {
1511     local nr=$1
1512     test $nr = 1 && echo -n $MDS_MKFS_OPTS || echo -n $MDSn_MKFS_OPTS
1513 }
1514
1515 formatall() {
1516     if [ "$IAMDIR" == "yes" ]; then
1517         MDS_MKFS_OPTS="$MDS_MKFS_OPTS --iam-dir"
1518         MDSn_MKFS_OPTS="$MDSn_MKFS_OPTS --iam-dir"
1519     fi
1520
1521     [ "$FSTYPE" ] && FSTYPE_OPT="--backfstype $FSTYPE"
1522
1523     if [ ! -z $SEC ]; then
1524         MDS_MKFS_OPTS="$MDS_MKFS_OPTS --param srpc.flavor.default=$SEC"
1525         MDSn_MKFS_OPTS="$MDSn_MKFS_OPTS --param srpc.flavor.default=$SEC"
1526         OST_MKFS_OPTS="$OST_MKFS_OPTS --param srpc.flavor.default=$SEC"
1527     fi
1528
1529     stopall
1530     # We need ldiskfs here, may as well load them all
1531     load_modules
1532     [ "$CLIENTONLY" ] && return
1533     echo "Formatting mdts, osts"
1534     for num in `seq $MDSCOUNT`; do
1535         echo "Format mds$num: $(mdsdevname $num)"
1536         if $VERBOSE; then
1537             add mds$num `mdsmkfsopts $num` $FSTYPE_OPT --reformat `mdsdevname $num` || exit 9
1538         else
1539             add mds$num `mdsmkfsopts $num` $FSTYPE_OPT --reformat `mdsdevname $num` > /dev/null || exit 9
1540         fi
1541     done
1542
1543     for num in `seq $OSTCOUNT`; do
1544         echo "Format ost$num: $(ostdevname $num)"
1545         if $VERBOSE; then
1546             add ost$num $OST_MKFS_OPTS --reformat `ostdevname $num` || exit 10
1547         else
1548             add ost$num $OST_MKFS_OPTS --reformat `ostdevname $num` > /dev/null || exit 10
1549         fi
1550     done
1551 }
1552
1553 mount_client() {
1554     grep " $1 " /proc/mounts || zconf_mount $HOSTNAME $*
1555 }
1556
1557 umount_client() {
1558     grep " $1 " /proc/mounts && zconf_umount `hostname` $*
1559 }
1560
1561 # return value:
1562 # 0: success, the old identity set already.
1563 # 1: success, the old identity does not set.
1564 # 2: fail.
1565 switch_identity() {
1566     local num=$1
1567     local switch=$2
1568     local j=`expr $num - 1`
1569     local MDT="`(do_facet mds$num lctl get_param -N mdt.*MDT*$j 2>/dev/null | cut -d"." -f2 2>/dev/null) || true`"
1570
1571     if [ -z "$MDT" ]; then
1572         return 2
1573     fi
1574
1575     local old="`do_facet mds$num "lctl get_param -n mdt.$MDT.identity_upcall"`"
1576
1577     if $switch; then
1578         do_facet mds$num "lctl set_param -n mdt.$MDT.identity_upcall \"$L_GETIDENTITY\""
1579     else
1580         do_facet mds$num "lctl set_param -n mdt.$MDT.identity_upcall \"NONE\""
1581     fi
1582
1583     do_facet mds$num "lctl set_param -n mdt/$MDT/identity_flush \"-1\""
1584
1585     if [ $old = "NONE" ]; then
1586         return 1
1587     else
1588         return 0
1589     fi
1590 }
1591
1592 remount_client()
1593 {
1594         zconf_umount `hostname` $1 || error "umount failed"
1595         zconf_mount `hostname` $1 || error "mount failed"
1596 }
1597
1598 writeconf_facet () {
1599     local facet=$1
1600     local dev=$2
1601
1602     do_facet $facet "$TUNEFS --writeconf $dev"
1603 }
1604
1605 writeconf_all () {
1606     for num in `seq $MDSCOUNT`; do
1607         DEVNAME=$(mdsdevname $num)
1608         writeconf_facet mds$num $DEVNAME
1609     done
1610
1611     for num in `seq $OSTCOUNT`; do
1612         DEVNAME=$(ostdevname $num)
1613         writeconf_facet ost$num $DEVNAME
1614     done
1615 }
1616
1617 setupall() {
1618     nfs_client_mode && return
1619
1620     sanity_mount_check ||
1621         error "environments are insane!"
1622
1623     load_modules
1624     init_gss
1625     if [ -z "$CLIENTONLY" ]; then
1626         echo "Setup mdts, osts"
1627         echo $WRITECONF | grep -q "writeconf" && \
1628             writeconf_all
1629         for num in `seq $MDSCOUNT`; do
1630             DEVNAME=$(mdsdevname $num)
1631             start mds$num $DEVNAME $MDS_MOUNT_OPTS
1632
1633             # We started mds, now we should set failover variables properly.
1634             # Set mds${num}failover_HOST if it is not set (the default failnode).
1635             local varname=mds${num}failover_HOST
1636             if [ -z "${!varname}" ]; then
1637                 eval mds${num}failover_HOST=$(facet_host mds$num)
1638             fi
1639
1640             if [ $IDENTITY_UPCALL != "default" ]; then
1641                 switch_identity $num $IDENTITY_UPCALL
1642             fi
1643         done
1644         for num in `seq $OSTCOUNT`; do
1645             DEVNAME=$(ostdevname $num)
1646             start ost$num $DEVNAME $OST_MOUNT_OPTS
1647
1648             # We started ost$num, now we should set ost${num}failover variable properly.
1649             # Set ost${num}failover_HOST if it is not set (the default failnode).
1650             varname=ost${num}failover_HOST
1651             if [ -z "${!varname}" ]; then
1652                 eval ost${num}failover_HOST=$(facet_host ost${num})
1653             fi
1654
1655         done
1656     fi
1657     # wait a while to allow sptlrpc configuration be propogated to targets,
1658     # only needed when mounting new target devices.
1659     $GSS && sleep 10
1660
1661     [ "$DAEMONFILE" ] && $LCTL debug_daemon start $DAEMONFILE $DAEMONSIZE
1662     mount_client $MOUNT
1663     [ -n "$CLIENTS" ] && zconf_mount_clients $CLIENTS $MOUNT
1664
1665     if [ "$MOUNT_2" ]; then
1666         mount_client $MOUNT2
1667         [ -n "$CLIENTS" ] && zconf_mount_clients $CLIENTS $MOUNT2
1668     fi
1669
1670     init_param_vars
1671
1672     # by remounting mdt before ost, initial connect from mdt to ost might
1673     # timeout because ost is not ready yet. wait some time to its fully
1674     # recovery. initial obd_connect timeout is 5s; in GSS case it's preceeded
1675     # by a context negotiation rpc with $TIMEOUT.
1676     # FIXME better by monitoring import status.
1677     if $GSS; then
1678         sleep $((TIMEOUT + 5))
1679     else
1680         sleep 5
1681     fi
1682 }
1683
1684 mounted_lustre_filesystems() {
1685         awk '($3 ~ "lustre" && $1 ~ ":") { print $2 }' /proc/mounts
1686 }
1687
1688 init_facet_vars () {
1689     [ "$CLIENTONLY" ] && return 0
1690     local facet=$1
1691     shift
1692     local device=$1
1693
1694     shift
1695
1696     eval export ${facet}_dev=${device}
1697     eval export ${facet}_opt=\"$@\"
1698
1699     local dev=${facet}_dev
1700     local label=$(do_facet ${facet} "$E2LABEL ${!dev}")
1701     [ -z "$label" ] && echo no label for ${!dev} && exit 1
1702
1703     eval export ${facet}_svc=${label}
1704
1705     local varname=${facet}failover_HOST
1706     if [ -z "${!varname}" ]; then
1707        eval $varname=$(facet_host $facet) 
1708     fi
1709
1710     # ${facet}failover_dev is set in cfg file
1711     varname=${facet}failover_dev
1712     if [ -n "${!varname}" ] ; then
1713         eval export ${facet}failover_dev=${!varname}
1714     else
1715         eval export ${facet}failover_dev=$device
1716     fi
1717 }
1718
1719 init_facets_vars () {
1720     local DEVNAME
1721
1722     if ! remote_mds_nodsh; then 
1723         for num in `seq $MDSCOUNT`; do
1724             DEVNAME=`mdsdevname $num`
1725             init_facet_vars mds$num $DEVNAME $MDS_MOUNT_OPTS
1726         done
1727     fi
1728
1729     remote_ost_nodsh && return
1730
1731     for num in `seq $OSTCOUNT`; do
1732         DEVNAME=`ostdevname $num`
1733         init_facet_vars ost$num $DEVNAME $OST_MOUNT_OPTS
1734     done
1735 }
1736
1737 mds_sanity_check () {
1738     local timeout=$1
1739     local period=0
1740
1741     while [ $period -lt $timeout ]; do
1742         count=$(do_facet $SINGLEMDS "lctl dl | grep 'osc.*mdtlov_UUID' | grep ' IN ' 2>/dev/null | wc -l")
1743         if [ $count -eq 0 ]; then
1744             break
1745         fi
1746
1747         echo "There are $count OST are inactive, wait $period seconds, and try again"
1748         sleep 3
1749         period=$((period+3))
1750     done
1751
1752     [ $period -lt $timeout ] || log "$count OST are inactive after $timeout seconds, give up"
1753 }
1754
1755 som_check() {
1756     SOM_ENABLED=$(do_facet $SINGLEMDS "$LCTL get_param mdt.*.som" | awk -F= ' {print $2}' | head -n 1)
1757     echo $SOM_ENABLED
1758 }
1759
1760 init_param_vars () {
1761     if ! remote_ost_nodsh && ! remote_mds_nodsh; then
1762         export MDSVER=$(do_facet $SINGLEMDS "lctl get_param version" | cut -d. -f1,2)
1763         export OSTVER=$(do_facet ost1 "lctl get_param version" | cut -d. -f1,2)
1764         export CLIVER=$(lctl get_param version | cut -d. -f 1,2)
1765     fi
1766
1767     remote_mds_nodsh ||
1768         TIMEOUT=$(do_facet $SINGLEMDS "lctl get_param -n timeout")
1769
1770     log "Using TIMEOUT=$TIMEOUT"
1771
1772     mds_sanity_check $TIMEOUT
1773
1774     if [ x"$(som_check)" = x"enabled" ]; then
1775         ENABLE_QUOTA=""
1776     fi
1777     if [ "$ENABLE_QUOTA" ]; then
1778         setup_quota $MOUNT  || return 2
1779     fi
1780 }
1781
1782 nfs_client_mode () {
1783     if [ "$NFSCLIENT" ]; then
1784         echo "NFSCLIENT mode: setup, cleanup, check config skipped"
1785         local clients=$CLIENTS
1786         [ -z $clients ] && clients=$(hostname)
1787
1788         # FIXME: remove hostname when 19215 fixed
1789         do_nodes $clients "echo \\\$(hostname); grep ' '$MOUNT' ' /proc/mounts"
1790         declare -a nfsexport=(`grep ' '$MOUNT' ' /proc/mounts | awk '{print $1}' | awk -F: '{print $1 " "  $2}'`)
1791         do_nodes ${nfsexport[0]} "echo \\\$(hostname); df -T  ${nfsexport[1]}"
1792         return
1793     fi
1794     return 1
1795 }
1796
1797 check_config () {
1798     nfs_client_mode && return
1799
1800     local mntpt=$1
1801
1802     local mounted=$(mount | grep " $mntpt ")
1803     if [ "$CLIENTONLY" ]; then
1804         # bug 18021
1805         # CLIENTONLY should not depend on *_HOST settings
1806         local mgc=$($LCTL device_list | awk '/MGC/ {print $4}')
1807         # in theory someone could create a new,
1808         # client-only config file that assumed lustre was already
1809         # configured and didn't set the MGSNID. If MGSNID is not set,
1810         # then we should use the mgs nid currently being used 
1811         # as the default value. bug 18021
1812         [[ x$MGSNID = x ]] &&
1813             MGSNID=${mgc//MGC/}
1814
1815         if [[ x$mgc != xMGC$MGSNID ]]; then
1816             if [ "$mgs_HOST" ]; then
1817                 local mgc_ip=$(ping -q -c1 -w1 $mgs_HOST | grep PING | awk '{print $3}' | sed -e "s/(//g" -e "s/)//g")
1818                 [[ x$mgc = xMGC$mgc_ip@$NETTYPE ]] ||
1819                     error_exit "MGSNID=$MGSNID, mounted: $mounted, MGC : $mgc"
1820             fi
1821         fi
1822         return 0
1823     fi
1824
1825     local myMGS_host=$mgs_HOST   
1826     if [ "$NETTYPE" = "ptl" ]; then
1827         myMGS_host=$(h2ptl $mgs_HOST | sed -e s/@ptl//) 
1828     fi
1829
1830     echo Checking config lustre mounted on $mntpt
1831     local mgshost=$(mount | grep " $mntpt " | awk -F@ '{print $1}')
1832     mgshost=$(echo $mgshost | awk -F: '{print $1}')
1833
1834     if [ "$mgshost" != "$myMGS_host" ]; then
1835             error_exit "Bad config file: lustre is mounted with mgs $mgshost, but mgs_HOST=$mgs_HOST, NETTYPE=$NETTYPE
1836                    Please use correct config or set mds_HOST correctly!"
1837     fi
1838
1839     sanity_mount_check ||
1840         error "environments are insane!"
1841 }
1842
1843 check_timeout () {
1844     local mdstimeout=$(do_facet $SINGLEMDS "lctl get_param -n timeout")
1845     local cltimeout=$(lctl get_param -n timeout)
1846     if [ $mdstimeout -ne $TIMEOUT ] || [ $mdstimeout -ne $cltimeout ]; then
1847         error "timeouts are wrong! mds: $mdstimeout, client: $cltimeout, TIMEOUT=$TIMEOUT"
1848         return 1
1849     fi
1850 }
1851
1852 check_and_setup_lustre() {
1853     nfs_client_mode && return
1854
1855     local MOUNTED=$(mounted_lustre_filesystems)
1856     if [ -z "$MOUNTED" ] || ! $(echo $MOUNTED | grep -w -q $MOUNT); then
1857         [ "$REFORMAT" ] && formatall
1858         setupall
1859         MOUNTED=$(mounted_lustre_filesystems | head -1)
1860         [ -z "$MOUNTED" ] && error "NAME=$NAME not mounted"
1861         export I_MOUNTED=yes
1862     else
1863         check_config $MOUNT
1864         init_facets_vars
1865         init_param_vars
1866
1867         do_nodes $(comma_list $(nodes_list)) "lctl set_param debug=\\\"$PTLDEBUG\\\";
1868             lctl set_param subsystem_debug=\\\"${SUBSYSTEM# }\\\";
1869             lctl set_param debug_mb=${DEBUG_SIZE};
1870             sync"
1871     fi
1872     if [ "$ONLY" == "setup" ]; then
1873         exit 0
1874     fi
1875 }
1876
1877 cleanup_and_setup_lustre() {
1878     if [ "$ONLY" == "cleanup" -o "`mount | grep $MOUNT`" ]; then
1879         lctl set_param debug=0 || true
1880         cleanupall
1881         if [ "$ONLY" == "cleanup" ]; then
1882             exit 0
1883         fi
1884     fi
1885     check_and_setup_lustre
1886 }
1887
1888 check_and_cleanup_lustre() {
1889     if [ "`mount | grep $MOUNT`" ]; then
1890         [ -n "$DIR" ] && rm -rf $DIR/[Rdfs][0-9]*
1891         [ "$ENABLE_QUOTA" ] && restore_quota_type || true
1892     fi
1893     if [ "$I_MOUNTED" = "yes" ]; then
1894         cleanupall -f || error "cleanup failed"
1895     fi
1896     unset I_MOUNTED
1897 }
1898
1899 #######
1900 # General functions
1901
1902 check_network() {
1903     local NETWORK=0
1904     local WAIT=0
1905     local MAX=$2
1906     while [ $NETWORK -eq 0 ]; do
1907         ping -c 1 -w 3 $1 > /dev/null
1908         if [ $? -eq 0 ]; then
1909             NETWORK=1
1910         else
1911             WAIT=$((WAIT + 5))
1912             echo "waiting for $1, $((MAX - WAIT)) secs left"
1913             sleep 5
1914         fi
1915         if [ $WAIT -gt $MAX ]; then
1916             echo "Network not available"
1917             exit 1
1918         fi
1919     done
1920 }
1921 check_port() {
1922     while( !($DSH2 $1 "netstat -tna | grep -q $2") ) ; do
1923         sleep 9
1924     done
1925 }
1926
1927 no_dsh() {
1928     shift
1929     eval $@
1930 }
1931
1932 comma_list() {
1933     # the sed converts spaces to commas, but leaves the last space
1934     # alone, so the line doesn't end with a comma.
1935     echo "$*" | tr -s " " "\n" | sort -b -u | tr "\n" " " | sed 's/ \([^$]\)/,\1/g'
1936 }
1937
1938 # list, excluded are the comma separated lists
1939 exclude_items_from_list () {
1940     local list=$1
1941     local excluded=$2
1942     local item
1943
1944     list=${list//,/ }
1945     for item in ${excluded//,/ }; do
1946         list=$(echo " $list " | sed -re "s/\s+$item\s+/ /g")
1947     done
1948     echo $(comma_list $list) 
1949 }
1950
1951 # list, expand  are the comma separated lists
1952 expand_list () {
1953     local list=${1//,/ }
1954     local expand=${2//,/ }
1955     local expanded=
1956
1957     expanded=$(for i in $list $expand; do echo $i; done | sort -u)
1958     echo $(comma_list $expanded)
1959 }
1960
1961 absolute_path() {
1962     (cd `dirname $1`; echo $PWD/`basename $1`)
1963 }
1964
1965 get_facets () {
1966     local name=$(echo $1 | tr "[:upper:]" "[:lower:]")
1967     local type=$(echo $1 | tr "[:lower:]" "[:upper:]")
1968
1969     local list=""
1970     local count=${type}COUNT
1971     for ((i=1; i<=${!count}; i++)) do
1972         list="$list ${name}$i"
1973     done
1974     echo $(comma_list $list)
1975 }
1976
1977 ##################################
1978 # Adaptive Timeouts funcs
1979
1980 at_is_enabled() {
1981     # only check mds, we assume at_max is the same on all nodes
1982     local at_max=$(do_facet $SINGLEMDS "lctl get_param -n at_max")
1983     if [ $at_max -eq 0 ]; then
1984         return 1
1985     else
1986         return 0
1987     fi
1988 }
1989
1990 at_max_get() {
1991     local facet=$1
1992
1993     # suppose that all ost-s has the same at_max set
1994     if [ $facet == "ost" ]; then
1995         do_facet ost1 "lctl get_param -n at_max"
1996     else
1997         do_facet $facet "lctl get_param -n at_max"
1998     fi
1999 }
2000
2001 at_max_set() {
2002     local at_max=$1
2003     shift
2004
2005     local facet
2006     for facet in $@; do
2007         if [ $facet == "ost" ]; then
2008             for i in `seq $OSTCOUNT`; do
2009                 do_facet ost$i "lctl set_param at_max=$at_max"
2010
2011             done
2012         elif [ $facet == "mds" ]; then
2013             for i in `seq $MDSCOUNT`; do
2014                 do_facet mds$i "lctl set_param at_max=$at_max"
2015             done
2016         else
2017             do_facet $facet "lctl set_param at_max=$at_max"
2018         fi
2019     done
2020 }
2021
2022 ##################################
2023 # OBD_FAIL funcs
2024
2025 drop_request() {
2026 # OBD_FAIL_MDS_ALL_REQUEST_NET
2027     RC=0
2028     do_facet $SINGLEMDS lctl set_param fail_loc=0x123
2029     do_facet client "$1" || RC=$?
2030     do_facet $SINGLEMDS lctl set_param fail_loc=0
2031     return $RC
2032 }
2033
2034 drop_reply() {
2035 # OBD_FAIL_MDS_ALL_REPLY_NET
2036     RC=0
2037     do_facet $SINGLEMDS lctl set_param fail_loc=0x122
2038     do_facet client "$@" || RC=$?
2039     do_facet $SINGLEMDS lctl set_param fail_loc=0
2040     return $RC
2041 }
2042
2043 drop_reint_reply() {
2044 # OBD_FAIL_MDS_REINT_NET_REP
2045     RC=0
2046     do_facet $SINGLEMDS lctl set_param fail_loc=0x119
2047     do_facet client "$@" || RC=$?
2048     do_facet $SINGLEMDS lctl set_param fail_loc=0
2049     return $RC
2050 }
2051
2052 pause_bulk() {
2053 #define OBD_FAIL_OST_BRW_PAUSE_BULK      0x214
2054     RC=0
2055     do_facet ost1 lctl set_param fail_loc=0x214
2056     do_facet client "$1" || RC=$?
2057     do_facet client "sync"
2058     do_facet ost1 lctl set_param fail_loc=0
2059     return $RC
2060 }
2061
2062 drop_ldlm_cancel() {
2063 #define OBD_FAIL_LDLM_CANCEL             0x304
2064     RC=0
2065     do_facet client lctl set_param fail_loc=0x304
2066     do_facet client "$@" || RC=$?
2067     do_facet client lctl set_param fail_loc=0
2068     return $RC
2069 }
2070
2071 drop_bl_callback() {
2072 #define OBD_FAIL_LDLM_BL_CALLBACK        0x305
2073     RC=0
2074     do_facet client lctl set_param fail_loc=0x305
2075     do_facet client "$@" || RC=$?
2076     do_facet client lctl set_param fail_loc=0
2077     return $RC
2078 }
2079
2080 drop_ldlm_reply() {
2081 #define OBD_FAIL_LDLM_REPLY              0x30c
2082     RC=0
2083     do_facet $SINGLEMDS lctl set_param fail_loc=0x30c
2084     do_facet client "$@" || RC=$?
2085     do_facet $SINGLEMDS lctl set_param fail_loc=0
2086     return $RC
2087 }
2088
2089 clear_failloc() {
2090     facet=$1
2091     pause=$2
2092     sleep $pause
2093     echo "clearing fail_loc on $facet"
2094     do_facet $facet "lctl set_param fail_loc=0 2>/dev/null || true"
2095 }
2096
2097 set_nodes_failloc () {
2098     do_nodes $(comma_list $1)  lctl set_param fail_loc=$2
2099 }
2100
2101 cancel_lru_locks() {
2102     $LCTL mark "cancel_lru_locks $1 start"
2103     for d in `lctl get_param -N ldlm.namespaces.*.lru_size | egrep -i $1`; do
2104         $LCTL set_param -n $d=clear
2105     done
2106     $LCTL get_param ldlm.namespaces.*.lock_unused_count | egrep -i $1 | grep -v '=0'
2107     $LCTL mark "cancel_lru_locks $1 stop"
2108 }
2109
2110 default_lru_size()
2111 {
2112         NR_CPU=$(grep -c "processor" /proc/cpuinfo)
2113         DEFAULT_LRU_SIZE=$((100 * NR_CPU))
2114         echo "$DEFAULT_LRU_SIZE"
2115 }
2116
2117 lru_resize_enable()
2118 {
2119     lctl set_param ldlm.namespaces.*$1*.lru_size=0
2120 }
2121
2122 lru_resize_disable()
2123 {
2124     lctl set_param ldlm.namespaces.*$1*.lru_size $(default_lru_size)
2125 }
2126
2127 pgcache_empty() {
2128     local FILE
2129     for FILE in `lctl get_param -N "llite.*.dump_page_cache"`; do
2130         if [ `lctl get_param -n $FILE | wc -l` -gt 1 ]; then
2131             echo there is still data in page cache $FILE ?
2132             lctl get_param -n $FILE
2133             return 1
2134         fi
2135     done
2136     return 0
2137 }
2138
2139 debugsave() {
2140     DEBUGSAVE="$(lctl get_param -n debug)"
2141 }
2142
2143 debugrestore() {
2144     [ -n "$DEBUGSAVE" ] && lctl set_param debug="${DEBUGSAVE}"
2145     DEBUGSAVE=""
2146 }
2147
2148 ##################################
2149 # Test interface
2150 ##################################
2151
2152 error_noexit() {
2153     local TYPE=${TYPE:-"FAIL"}
2154     local ERRLOG
2155     lctl set_param fail_loc=0 2>/dev/null || true
2156     log " ${TESTSUITE} ${TESTNAME}: @@@@@@ ${TYPE}: $@ "
2157     ERRLOG=$TMP/lustre_${TESTSUITE}_${TESTNAME}.$(date +%s)
2158     echo "Dumping lctl log to $ERRLOG"
2159     # We need to dump the logs on all nodes
2160     do_nodes $(comma_list $(nodes_list)) $NODE $LCTL dk $ERRLOG
2161     debugrestore
2162     [ "$TESTSUITELOG" ] && echo "$0: ${TYPE}: $TESTNAME $@" >> $TESTSUITELOG
2163     TEST_FAILED=true
2164 }
2165
2166 error() {
2167     error_noexit "$@"
2168     $FAIL_ON_ERROR && exit 1 || true
2169 }
2170
2171 error_exit() {
2172     error_noexit "$@"
2173     exit 1
2174 }
2175
2176 # use only if we are ignoring failures for this test, bugno required.
2177 # (like ALWAYS_EXCEPT, but run the test and ignore the results.)
2178 # e.g. error_ignore 5494 "your message"
2179 error_ignore() {
2180     local TYPE="IGNORE (bz$1)"
2181     shift
2182     error_noexit "$@"
2183 }
2184
2185 skip () {
2186     echo
2187     log " SKIP: ${TESTSUITE} ${TESTNAME} $@"
2188     [ "$TESTSUITELOG" ] && \
2189         echo "${TESTSUITE}: SKIP: $TESTNAME $@" >> $TESTSUITELOG || true
2190 }
2191
2192 build_test_filter() {
2193     [ "$ONLY" ] && log "only running test `echo $ONLY`"
2194     for O in $ONLY; do
2195         eval ONLY_${O}=true
2196     done
2197     [ "$EXCEPT$ALWAYS_EXCEPT" ] && \
2198         log "excepting tests: `echo $EXCEPT $ALWAYS_EXCEPT`"
2199     [ "$EXCEPT_SLOW" ] && \
2200         log "skipping tests SLOW=no: `echo $EXCEPT_SLOW`"
2201     for E in $EXCEPT $ALWAYS_EXCEPT; do
2202         eval EXCEPT_${E}=true
2203     done
2204     for E in $EXCEPT_SLOW; do
2205         eval EXCEPT_SLOW_${E}=true
2206     done
2207     for G in $GRANT_CHECK_LIST; do
2208         eval GCHECK_ONLY_${G}=true
2209         done
2210 }
2211
2212 _basetest() {
2213     echo $*
2214 }
2215
2216 basetest() {
2217     IFS=abcdefghijklmnopqrstuvwxyz _basetest $1
2218 }
2219
2220 # print a newline if the last test was skipped
2221 export LAST_SKIPPED=
2222 run_test() {
2223     assert_DIR
2224
2225     export base=`basetest $1`
2226     if [ ! -z "$ONLY" ]; then
2227         testname=ONLY_$1
2228         if [ ${!testname}x != x ]; then
2229             [ "$LAST_SKIPPED" ] && echo "" && LAST_SKIPPED=
2230             run_one $1 "$2"
2231             return $?
2232         fi
2233         testname=ONLY_$base
2234         if [ ${!testname}x != x ]; then
2235             [ "$LAST_SKIPPED" ] && echo "" && LAST_SKIPPED=
2236             run_one $1 "$2"
2237             return $?
2238         fi
2239         LAST_SKIPPED="y"
2240         echo -n "."
2241         return 0
2242     fi
2243     testname=EXCEPT_$1
2244     if [ ${!testname}x != x ]; then
2245         LAST_SKIPPED="y"
2246         TESTNAME=test_$1 skip "skipping excluded test $1"
2247         return 0
2248     fi
2249     testname=EXCEPT_$base
2250     if [ ${!testname}x != x ]; then
2251         LAST_SKIPPED="y"
2252         TESTNAME=test_$1 skip "skipping excluded test $1 (base $base)"
2253         return 0
2254     fi
2255     testname=EXCEPT_SLOW_$1
2256     if [ ${!testname}x != x ]; then
2257         LAST_SKIPPED="y"
2258         TESTNAME=test_$1 skip "skipping SLOW test $1"
2259         return 0
2260     fi
2261     testname=EXCEPT_SLOW_$base
2262     if [ ${!testname}x != x ]; then
2263         LAST_SKIPPED="y"
2264         TESTNAME=test_$1 skip "skipping SLOW test $1 (base $base)"
2265         return 0
2266     fi
2267
2268     LAST_SKIPPED=
2269     run_one $1 "$2"
2270
2271     return $?
2272 }
2273
2274 EQUALS="======================================================================"
2275 equals_msg() {
2276     msg="$@"
2277
2278     local suffixlen=$((${#EQUALS} - ${#msg}))
2279     [ $suffixlen -lt 5 ] && suffixlen=5
2280     log `echo $(printf '===== %s %.*s\n' "$msg" $suffixlen $EQUALS)`
2281 }
2282
2283 log() {
2284     echo "$*"
2285     lsmod | grep lnet > /dev/null || load_modules
2286
2287     local MSG="$*"
2288     # Get rid of '
2289     MSG=${MSG//\'/\\\'}
2290     MSG=${MSG//\(/\\\(}
2291     MSG=${MSG//\)/\\\)}
2292     MSG=${MSG//\;/\\\;}
2293     MSG=${MSG//\|/\\\|}
2294     MSG=${MSG//\>/\\\>}
2295     MSG=${MSG//\</\\\<}
2296     MSG=${MSG//\//\\\/}
2297     do_nodes $(comma_list $(nodes_list)) $LCTL mark "$MSG" 2> /dev/null || true
2298 }
2299
2300 trace() {
2301         log "STARTING: $*"
2302         strace -o $TMP/$1.strace -ttt $*
2303         RC=$?
2304         log "FINISHED: $*: rc $RC"
2305         return 1
2306 }
2307
2308 pass() {
2309     $TEST_FAILED && echo -n "FAIL " || echo -n "PASS " 
2310     echo $@
2311 }
2312
2313 check_mds() {
2314     FFREE=$(do_node $SINGLEMDS lctl get_param -n osd.*MDT*.filesfree | awk 'BEGIN{avail=0}; {avail+=$1}; END{print avail}')
2315     FTOTAL=$(do_node $SINGLEMDS lctl get_param -n osd.*MDT*.filestotal | awk 'BEGIN{avail=0}; {avail+=$1}; END{print avail}')
2316     [ $FFREE -ge $FTOTAL ] && error "files free $FFREE > total $FTOTAL" || true
2317 }
2318
2319 reset_fail_loc () {
2320     echo -n "Resetting fail_loc on all nodes..."
2321     do_nodes $(comma_list $(nodes_list)) "lctl set_param -n fail_loc=0 2>/dev/null || true"
2322     echo done.
2323 }
2324
2325 run_one() {
2326     testnum=$1
2327     message=$2
2328     tfile=f${testnum}
2329     export tdir=d0.${TESTSUITE}/d${base}
2330
2331     local SAVE_UMASK=`umask`
2332     umask 0022
2333
2334     local BEFORE=`date +%s`
2335     echo
2336     log "== test $testnum: $message == `date +%H:%M:%S` ($BEFORE)"
2337     #check_mds
2338     export TESTNAME=test_$testnum
2339     TEST_FAILED=false
2340     test_${testnum} || error "test_$testnum failed with $?"
2341     #check_mds
2342     cd $SAVE_PWD
2343     reset_fail_loc
2344     check_grant ${testnum} || error "check_grant $testnum failed with $?"
2345     check_catastrophe || error "LBUG/LASSERT detected"
2346     ps auxww | grep -v grep | grep -q multiop && error "multiop still running"
2347     pass "($((`date +%s` - $BEFORE))s)"
2348     TEST_FAILED=false
2349     unset TESTNAME
2350     unset tdir
2351     umask $SAVE_UMASK
2352 }
2353
2354 canonical_path() {
2355     (cd `dirname $1`; echo $PWD/`basename $1`)
2356 }
2357
2358 sync_clients() {
2359     [ -d $DIR1 ] && cd $DIR1 && sync; sleep 1; sync
2360     [ -d $DIR2 ] && cd $DIR2 && sync; sleep 1; sync
2361         cd $SAVE_PWD
2362 }
2363
2364 check_grant() {
2365     export base=`basetest $1`
2366     [ "$CHECK_GRANT" == "no" ] && return 0
2367
2368         testname=GCHECK_ONLY_${base}
2369         [ ${!testname}x == x ] && return 0
2370
2371     echo -n "checking grant......"
2372         cd $SAVE_PWD
2373         # write some data to sync client lost_grant
2374         rm -f $DIR1/${tfile}_check_grant_* 2>&1
2375         for i in `seq $OSTCOUNT`; do
2376                 $LFS setstripe $DIR1/${tfile}_check_grant_$i -i $(($i -1)) -c 1
2377                 dd if=/dev/zero of=$DIR1/${tfile}_check_grant_$i bs=4k \
2378                                               count=1 > /dev/null 2>&1
2379         done
2380         # sync all the data and make sure no pending data on server
2381         sync_clients
2382         
2383         #get client grant and server grant
2384         client_grant=0
2385     for d in `lctl get_param -n osc.*.cur_grant_bytes`; do
2386                 client_grant=$((client_grant + $d))
2387         done
2388         server_grant=0
2389         for d in `lctl get_param -n obdfilter.*.tot_granted`; do
2390                 server_grant=$((server_grant + $d))
2391         done
2392
2393         # cleanup the check_grant file
2394         for i in `seq $OSTCOUNT`; do
2395                 rm $DIR1/${tfile}_check_grant_$i
2396         done
2397
2398         #check whether client grant == server grant
2399         if [ $client_grant != $server_grant ]; then
2400                 echo "failed: client:${client_grant} server: ${server_grant}"
2401                 return 1
2402         else
2403                 echo "pass"
2404         fi
2405 }
2406
2407 ########################
2408 # helper functions
2409
2410 osc_to_ost()
2411 {
2412     osc=$1
2413     ost=`echo $1 | awk -F_ '{print $3}'`
2414     if [ -z $ost ]; then
2415         ost=`echo $1 | sed 's/-osc.*//'`
2416     fi
2417     echo $ost
2418 }
2419
2420 remote_node () {
2421     local node=$1
2422     [ "$node" != "$(hostname)" ]
2423 }
2424
2425 remote_mds ()
2426 {
2427     local node
2428     for node in $(mdts_nodes); do
2429         remote_node $node && return 0
2430     done
2431     return 1
2432 }
2433
2434 remote_mds_nodsh()
2435 {
2436     [ "$CLIENTONLY" ] && return 0 || true
2437     remote_mds && [ "$PDSH" = "no_dsh" -o -z "$PDSH" -o -z "$mds_HOST" ]
2438 }
2439
2440 remote_ost ()
2441 {
2442     local node
2443     for node in $(osts_nodes) ; do
2444         remote_node $node && return 0
2445     done
2446     return 1
2447 }
2448
2449 remote_ost_nodsh()
2450 {
2451     [ "$CLIENTONLY" ] && return 0 || true 
2452     remote_ost && [ "$PDSH" = "no_dsh" -o -z "$PDSH" -o -z "$ost_HOST" ]
2453 }
2454
2455 remote_mgs_nodsh()
2456 {
2457     local MGS 
2458     MGS=$(facet_host mgs)
2459     remote_node $MGS && [ "$PDSH" = "no_dsh" -o -z "$PDSH" -o -z "$ost_HOST" ]
2460 }
2461
2462 mdts_nodes () {
2463     local MDSNODES
2464     local NODES_sort
2465     for num in `seq $MDSCOUNT`; do
2466         MDSNODES="$MDSNODES $(facet_host mds$num)"
2467     done
2468     NODES_sort=$(for i in $MDSNODES; do echo $i; done | sort -u)
2469
2470     echo $NODES_sort
2471 }
2472
2473 remote_servers () {
2474     remote_ost && remote_mds
2475 }
2476
2477 osts_nodes () {
2478     local OSTNODES=$(facet_host ost1)
2479     local NODES_sort
2480
2481     for num in `seq $OSTCOUNT`; do
2482         local myOST=$(facet_host ost$num)
2483         OSTNODES="$OSTNODES $myOST"
2484     done
2485     NODES_sort=$(for i in $OSTNODES; do echo $i; done | sort -u)
2486
2487     echo $NODES_sort
2488 }
2489
2490 nodes_list () {
2491     # FIXME. We need a list of clients
2492     local myNODES=$HOSTNAME
2493     local myNODES_sort
2494
2495     # CLIENTS (if specified) contains the local client
2496     [ -n "$CLIENTS" ] && myNODES=${CLIENTS//,/ }
2497
2498     if [ "$PDSH" -a "$PDSH" != "no_dsh" ]; then
2499         myNODES="$myNODES $(osts_nodes) $(mdts_nodes)"
2500     fi
2501
2502     myNODES_sort=$(for i in $myNODES; do echo $i; done | sort -u)
2503
2504     echo $myNODES_sort
2505 }
2506
2507 remote_nodes_list () {
2508     local rnodes=$(nodes_list)
2509     rnodes=$(echo " $rnodes " | sed -re "s/\s+$HOSTNAME\s+/ /g")
2510     echo $rnodes
2511 }
2512
2513 init_clients_lists () {
2514     # Sanity check: exclude the local client from RCLIENTS
2515     local rclients=$(echo " $RCLIENTS " | sed -re "s/\s+$HOSTNAME\s+/ /g")
2516
2517     # Sanity check: exclude the dup entries
2518     rclients=$(for i in $rclients; do echo $i; done | sort -u)
2519
2520     local clients="$SINGLECLIENT $HOSTNAME $rclients"
2521
2522     # Sanity check: exclude the dup entries from CLIENTS
2523     # for those configs which has SINGLCLIENT set to local client
2524     clients=$(for i in $clients; do echo $i; done | sort -u)
2525
2526     CLIENTS=`comma_list $clients`
2527     local -a remoteclients=($rclients)
2528     for ((i=0; $i<${#remoteclients[@]}; i++)); do
2529             varname=CLIENT$((i + 2))
2530             eval $varname=${remoteclients[i]}
2531     done
2532
2533     CLIENTCOUNT=$((${#remoteclients[@]} + 1))
2534 }
2535
2536 get_random_entry () {
2537     local rnodes=$1
2538
2539     rnodes=${rnodes//,/ }
2540
2541     local -a nodes=($rnodes)
2542     local num=${#nodes[@]} 
2543     local i=$((RANDOM * num * 2 / 65536))
2544
2545     echo ${nodes[i]}
2546 }
2547
2548 is_patchless ()
2549 {
2550     lctl get_param version | grep -q patchless
2551 }
2552
2553 check_versions () {
2554     [ "$MDSVER" = "$CLIVER" -a "$OSTVER" = "$CLIVER" ]
2555 }
2556
2557 get_node_count() {
2558     local nodes="$@"
2559     echo $nodes | wc -w || true
2560 }
2561
2562 mixed_ost_devs () {
2563     local nodes=$(osts_nodes)
2564     local osscount=$(get_node_count "$nodes")
2565     [ ! "$OSTCOUNT" = "$osscount" ]
2566 }
2567
2568 mixed_mdt_devs () {
2569     local nodes=$(mdts_nodes)
2570     local mdtcount=$(get_node_count "$nodes")
2571     [ ! "$MDSCOUNT" = "$mdtcount" ]
2572 }
2573
2574 generate_machine_file() {
2575     local nodes=${1//,/ }
2576     local machinefile=$2
2577     rm -f $machinefile || error "can't rm $machinefile"
2578     for node in $nodes; do
2579         echo $node >>$machinefile
2580     done
2581 }
2582
2583 get_stripe () {
2584     local file=$1/stripe
2585     touch $file
2586     $LFS getstripe -v $file || error
2587     rm -f $file
2588 }
2589
2590 check_runas_id_ret() {
2591     local myRC=0
2592     local myRUNAS_UID=$1
2593     local myRUNAS_GID=$2
2594     shift 2
2595     local myRUNAS=$@
2596     if [ -z "$myRUNAS" ]; then
2597         error_exit "myRUNAS command must be specified for check_runas_id"
2598     fi
2599     if $GSS_KRB5; then
2600         $myRUNAS krb5_login.sh || \
2601             error "Failed to refresh Kerberos V5 TGT for UID $myRUNAS_ID."
2602     fi
2603     mkdir $DIR/d0_runas_test
2604     chmod 0755 $DIR
2605     chown $myRUNAS_UID:$myRUNAS_GID $DIR/d0_runas_test
2606     $myRUNAS touch $DIR/d0_runas_test/f$$ || myRC=$?
2607     rm -rf $DIR/d0_runas_test
2608     return $myRC
2609 }
2610
2611 check_runas_id() {
2612     local myRUNAS_UID=$1
2613     local myRUNAS_GID=$2
2614     shift 2
2615     local myRUNAS=$@
2616     check_runas_id_ret $myRUNAS_UID $myRUNAS_GID $myRUNAS || \
2617         error "unable to write to $DIR/d0_runas_test as UID $myRUNAS_UID.
2618         Please set RUNAS_ID to some UID which exists on MDS and client or
2619         add user $myRUNAS_UID:$myRUNAS_GID on these nodes."
2620 }
2621
2622 # obtain the UID/GID for MPI_USER
2623 get_mpiuser_id() {
2624     local mpi_user=$1
2625
2626     MPI_USER_UID=$(do_facet client "getent passwd $mpi_user | cut -d: -f3;
2627 exit \\\${PIPESTATUS[0]}") || error_exit "failed to get the UID for $mpi_user"
2628
2629     MPI_USER_GID=$(do_facet client "getent passwd $mpi_user | cut -d: -f4;
2630 exit \\\${PIPESTATUS[0]}") || error_exit "failed to get the GID for $mpi_user"
2631 }
2632
2633 # obtain and cache Kerberos ticket-granting ticket
2634 refresh_krb5_tgt() {
2635     local myRUNAS_UID=$1
2636     local myRUNAS_GID=$2
2637     shift 2
2638     local myRUNAS=$@
2639     if [ -z "$myRUNAS" ]; then
2640         error_exit "myRUNAS command must be specified for refresh_krb5_tgt"
2641     fi
2642
2643     CLIENTS=${CLIENTS:-$HOSTNAME}
2644     do_nodes $CLIENTS "set -x
2645 if ! $myRUNAS krb5_login.sh; then
2646     echo "Failed to refresh Krb5 TGT for UID/GID $myRUNAS_UID/$myRUNAS_GID."
2647     exit 1
2648 fi"
2649 }
2650
2651 # Run multiop in the background, but wait for it to print
2652 # "PAUSING" to its stdout before returning from this function.
2653 multiop_bg_pause() {
2654     MULTIOP_PROG=${MULTIOP_PROG:-multiop}
2655     FILE=$1
2656     ARGS=$2
2657
2658     TMPPIPE=/tmp/multiop_open_wait_pipe.$$
2659     mkfifo $TMPPIPE
2660
2661     echo "$MULTIOP_PROG $FILE v$ARGS"
2662     $MULTIOP_PROG $FILE v$ARGS > $TMPPIPE &
2663
2664     echo "TMPPIPE=${TMPPIPE}"
2665     read -t 60 multiop_output < $TMPPIPE
2666     if [ $? -ne 0 ]; then
2667         rm -f $TMPPIPE
2668         return 1
2669     fi
2670     rm -f $TMPPIPE
2671     if [ "$multiop_output" != "PAUSING" ]; then
2672         echo "Incorrect multiop output: $multiop_output"
2673         kill -9 $PID
2674         return 1
2675     fi
2676
2677     return 0
2678 }
2679
2680 do_and_time () {
2681     local cmd=$1
2682     local rc
2683
2684     SECONDS=0
2685     eval '$cmd'
2686     
2687     [ ${PIPESTATUS[0]} -eq 0 ] || rc=1
2688
2689     echo $SECONDS
2690     return $rc
2691 }
2692
2693 inodes_available () {
2694     local IFree=$($LFS df -i $MOUNT | grep ^$FSNAME | awk '{print $4}' | sort -un | head -1) || return 1
2695     echo $IFree
2696 }
2697
2698 # reset llite stat counters
2699 clear_llite_stats(){
2700         lctl set_param -n llite.*.stats 0
2701 }
2702
2703 # sum llite stat items
2704 calc_llite_stats() {
2705         local res=$(lctl get_param -n llite.*.stats |
2706                     awk 'BEGIN {s = 0} END {print s} /^'"$1"'/ {s += $2}')
2707         echo $res
2708 }
2709
2710 # reset osc stat counters
2711 clear_osc_stats(){
2712         lctl set_param -n osc.*.osc_stats 0
2713 }
2714
2715 # sum osc stat items
2716 calc_osc_stats() {
2717         local res=$(lctl get_param -n osc.*.osc_stats |
2718                     awk 'BEGIN {s = 0} END {print s} /^'"$1"'/ {s += $2}')
2719         echo $res
2720 }
2721
2722 calc_sum () {
2723         awk 'BEGIN {s = 0}; {s += $1}; END {print s}'
2724 }
2725
2726 calc_osc_kbytes () {
2727         df $MOUNT > /dev/null
2728         $LCTL get_param -n osc.*[oO][sS][cC][-_][0-9a-f]*.$1 | calc_sum
2729 }
2730
2731 # save_lustre_params(node, parameter_mask)
2732 # generate a stream of formatted strings (<node> <param name>=<param value>)
2733 save_lustre_params() {
2734         local s
2735         do_nodes --verbose $1 "lctl get_param $2 | while read s; do echo \\\$s; done"
2736 }
2737
2738 # restore lustre parameters from input stream, produces by save_lustre_params
2739 restore_lustre_params() {
2740         local node
2741         local name
2742         local val
2743         while IFS=" =" read node name val; do
2744                 do_node ${node//:/} "lctl set_param -n $name $val"
2745         done
2746 }
2747
2748 check_catastrophe() {
2749     local rnodes=${1:-$(comma_list $(remote_nodes_list))}
2750     local C=$CATASTROPHE
2751     [ -f $C ] && [ $(cat $C) -ne 0 ] && return 1
2752
2753     if [ $rnodes ]; then
2754         do_nodes $rnodes "rc=\\\$([ -f $C ] && echo \\\$(< $C) || echo 0);
2755 if [ \\\$rc -ne 0 ]; then echo \\\$(hostname): \\\$rc; fi
2756 exit \\\$rc;"
2757     fi 
2758 }
2759
2760 # $1 node
2761 # $2 file
2762 # $3 $RUNAS
2763 get_stripe_info() {
2764         local tmp_file
2765
2766         stripe_size=0
2767         stripe_count=0
2768         stripe_index=0
2769         tmp_file=$(mktemp)
2770
2771         do_facet $1 $3 lfs getstripe -v $2 > $tmp_file
2772
2773         stripe_size=`awk '$1 ~ /size/ {print $2}' $tmp_file`
2774         stripe_count=`awk '$1 ~ /count/ {print $2}' $tmp_file`
2775         stripe_index=`awk '$1 ~ /stripe_offset/ {print $2}' $tmp_file`
2776         rm -f $tmp_file
2777 }
2778
2779 # CMD: determine mds index where directory inode presents
2780 get_mds_dir () {
2781     local dir=$1
2782     local file=$dir/f0.get_mds_dir_tmpfile
2783
2784     rm -f $file
2785     sleep 1
2786     local iused=$(lfs df -i $dir | grep MDT | awk '{print $3}')
2787     local -a oldused=($iused)
2788
2789     touch $file
2790     sleep 1
2791     iused=$(lfs df -i $dir | grep MDT | awk '{print $3}')
2792     local -a newused=($iused)
2793
2794     local num=0
2795     for ((i=0; i<${#newused[@]}; i++)); do
2796          if [ ${oldused[$i]} -lt ${newused[$i]} ];  then
2797              echo $(( i + 1 ))
2798              rm -f $file
2799              return 0
2800          fi
2801     done
2802     error "mdt-s : inodes count OLD ${oldused[@]} NEW ${newused[@]}"
2803 }
2804
2805 mdsrate_cleanup () {
2806     mpi_run -np $1 -machinefile $2 ${MDSRATE} --unlink --nfiles $3 --dir $4 --filefmt $5 $6
2807 }
2808
2809 delayed_recovery_enabled () {
2810     local var=${SINGLEMDS}_svc
2811     do_facet $SINGLEMDS lctl get_param -n mdd.${!var}.stale_export_age > /dev/null 2>&1
2812 }
2813
2814 ########################
2815 convert_facet2name() {
2816     case "$1" in
2817         "ost" ) echo "OST0000" ;;
2818         "ost1") echo "OST0000" ;;
2819         "ost2") echo "OST0001" ;;
2820         "ost3") echo "OST0002" ;;
2821         "ost4") echo "OST0003" ;;
2822         "ost5") echo "OST0004" ;;
2823         *) error "unknown facet!" ;;
2824     esac
2825 }
2826
2827 get_clientosc_proc_path() {
2828     local ost=$1
2829
2830     echo "{$1}-osc-*"
2831 }
2832
2833 get_lustre_version () {
2834     local node=${1:-"mds"}    
2835     do_facet $node $LCTL get_param -n version |  awk '/^lustre:/ {print $2}'
2836 }
2837
2838 get_mds_version_major () {
2839     local version=$(get_lustre_version mds)
2840     echo $version | awk -F. '{print $1}'
2841 }
2842
2843 get_mds_version_minor () {
2844     local version=$(get_lustre_version mds)
2845     echo $version | awk -F. '{print $2}'
2846 }
2847
2848 get_mdtosc_proc_path() {
2849     local ost=$1
2850     local major=$(get_mds_version_major)
2851     local minor=$(get_mds_version_minor)
2852     if [ $major -le 1 -a $minor -le 8 ] ; then
2853         echo "${ost}-osc"
2854     else
2855         echo "${ost}-osc-MDT0000"
2856     fi
2857 }
2858
2859 get_osc_import_name() {
2860     local node=$1
2861     local ost=$2
2862     local name=$(convert_facet2name $ost)
2863
2864     if [ "$node" == "mds" ]; then
2865         get_mdtosc_proc_path $name
2866         return 0
2867     fi
2868
2869     get_clientosc_proc_path $name
2870     return 0
2871 }
2872
2873 wait_osc_import_state() {
2874     local node=$1
2875     local ost_facet=$2
2876     local expected=$3
2877     local ost=$(get_osc_import_name $node $ost_facet)
2878     local CONN_PROC
2879     local CONN_STATE
2880     local i=0
2881
2882     CONN_PROC="osc.${FSNAME}-${ost}.ost_server_uuid"
2883     CONN_STATE=$(do_facet $node lctl get_param -n $CONN_PROC 2>/dev/null | cut -f2)
2884     while [ "${CONN_STATE}" != "${expected}" ]; do
2885         if [ "${expected}" == "DISCONN" ]; then 
2886             # for disconn we can check after proc entry is removed
2887             [ "x${CONN_STATE}" == "x" ] && return 0
2888             #  with AT we can have connect request timeout ~ reconnect timeout
2889             # and test can't see real disconnect
2890             [ "${CONN_STATE}" == "CONNECTING" ] && return 0
2891         fi
2892         # disconnect rpc should be wait not more obd_timeout
2893         [ $i -ge $(($TIMEOUT * 3 / 2)) ] && \
2894             error "can't put import for ${ost}(${ost_facet}) into ${expected} state" && return 1
2895         sleep 1
2896         CONN_STATE=$(do_facet $node lctl get_param -n $CONN_PROC 2>/dev/null | cut -f2)
2897         i=$(($i + 1))
2898     done
2899
2900     log "${ost_facet} now in ${CONN_STATE} state"
2901     return 0
2902 }